from . import download
download.downloading()

bl_info = {
    "name" : "KaFire vfxMed",
    "author" : "Picto Filmo", 
    "description" : "",
    "blender" : (3, 3, 0),
    "version" : (1, 1, 5),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import blf
import gpu
from gpu_extras.batch import batch_for_shader
import bgl
import math
import random
import bmesh
from math import sqrt, atan, pi
import os
from bpy.app.handlers import persistent
from math import sin, cos, pi
import bl_math
import addon_utils
from . import translate


addon_keymaps = {}
_icons = None
kafire = {'sna_tmp_fire': None, 'sna_tmp_direction': None, 'sna_tmp_fire_mesh': None, }
class dotdict(dict):
    __getattr__ = dict.get
    __setattr__ = dict.__setitem__
    __delattr__ = dict.__delitem__


handler_961E1 = []


def region_by_type(area, region_type):
    for region in area.regions:
        if region.type == region_type:
            return region
    return area.regions[0]


def sna_move_outliner_collection_object_A90B9_7CA1B(object, collection_name):
    ob = object
    coll_name = collection_name
    object_old_coll = object.users_collection
    collection = bpy.data.collections.get( collection_name )
    if collection not in object_old_coll:
        if collection is None:
            collection = bpy.data.collections.new( collection_name )
            bpy.context.scene.collection.children.link( collection )
        collection.objects.link( object )
        for coll in object_old_coll:
            coll.objects.unlink(object)


def sna_update_edit_lock_BBBEE(self, context):
    sna_updated_prop = self.edit_lock
    manip = self.manipulator
    lock = sna_updated_prop
    angle = self.manipulator.sna_kfire_angle
    ring = self.ring
    import math   
    #try:
    #    text = bpy.data.texts['Debug']
    #except:
    #    bpy.data.texts.new('Debug')
    #def debug(*args):
    #    msg = ''
    #    for a in args:
    #        msg+=str(a)
    #    msg += '\n'
    #    return msg

    def ToSperical(x,y,z,f):
        if z > 0:
            if x > 0:
                if y > 0:               
                    phi = atan(sqrt(x*x+y*y)/z) * f
                    theta = atan(y/x) - (1-f)*pi/2
                else:
                    phi = atan(sqrt(x*x+y*y)/z) * f
                    theta = atan(y/x) + (1-f)*pi/2
            else:
                if y > 0:                
                    phi = atan(sqrt(x*x+y*y)/z) * f
                    theta = atan(y/x) + pi - (1-f)*pi/2
                else:
                    phi = atan(sqrt(x*x+y*y)/z) * f
                    theta = atan(y/x) - pi + (1-f)*pi/2
        else:
            if x > 0:
                if y > 0:                
                    phi = atan(sqrt(x*x+y*y)/z) * f - pi 
                    theta = atan(y/x) - (1-f)*pi/2
                else:
                    phi = (atan(sqrt(x*x+y*y)/z) + pi) * f
                    theta = atan(y/x) + (1-f)*pi/2
            else:
                if y > 0:                
                    phi = (atan(sqrt(x*x+y*y)/z) + pi ) * f
                    theta = atan(y/x) + pi - (1-f)*pi/2
                else:
                    phi = (atan(sqrt(x*x+y*y)/z) - pi) * f
                    theta = atan(y/x) - pi + (1-f)*pi/2
        return theta,phi
    if lock:
        try:
            for torch in manip.children:
                normalize_scale = 1/torch.empty_display_size
                Vtorch = normalize_scale*torch.matrix_local.col[2].to_3d()
                teta,fi = ToSperical(Vtorch[0],Vtorch[1],Vtorch[2],math.copysign(1.0,torch['Fire_kfi']))        
        #        text.write(debug('VTorch=',Vtorch[0],',',Vtorch[1],',',Vtorch[2]))
        #        text.write(debug('old fi=',torch['Fire_kfi'],' real fi=',fi, '  fi/angle=', fi/angle))
                if abs(fi) > pi:
                    if fi>0:
                        fi = fi - 2*pi
                    else:
                        fi = 2*pi + fi
                if fi > 0 and fi > angle:
                    fi = angle
                if fi < 0 and fi < -angle:
                    fi = -angle
                if fi > 0 and fi < angle*ring:
                    fi = angle*ring
                if fi < 0 and fi > -angle*ring:
                    fi = -angle*ring
                s = math.copysign(1.0,torch['Fire_kfi'])
                torch['Fire_kfi'] = (fi - s*ring*angle)/(angle-ring*angle)
                torch['Fire_teta'] = teta
                torch.hide_select = True
        except:
            pass
    else:
        for torch in manip.children:
            torch.hide_select = False
    sna_update_fire_CF4A5(self.manipulator, self, 0)


def sna_move_outliner_collection_object_A90B9_61FC7(object, collection_name):
    ob = object
    coll_name = collection_name
    object_old_coll = object.users_collection
    collection = bpy.data.collections.get( collection_name )
    if collection not in object_old_coll:
        if collection is None:
            collection = bpy.data.collections.new( collection_name )
            bpy.context.scene.collection.children.link( collection )
        collection.objects.link( object )
        for coll in object_old_coll:
            coll.objects.unlink(object)


def sna_update_number_D7CC9(self, context):
    sna_updated_prop = self.number
    sna_update_fire_CF4A5(self.manipulator, self, bpy.context.scene.sna_fire_index)


def display_collection_id(uid, vars):
    id = f"coll_{uid}"
    for var in vars.keys():
        if var.startswith("i_"):
            id += f"_{var}_{vars[var]}"
    return id


class SNA_UL_display_collection_list_AE408(bpy.types.UIList):

    def draw_item(self, context, layout, data, item_AE408, icon, active_data, active_propname, index_AE408):
        row = layout
        split_986A8 = layout.split(factor=0.20000000298023224, align=False)
        split_986A8.alert = False
        split_986A8.enabled = True
        split_986A8.active = True
        split_986A8.use_property_split = False
        split_986A8.use_property_decorate = False
        split_986A8.scale_x = 1.0
        split_986A8.scale_y = 1.0
        split_986A8.alignment = 'Expand'.upper()
        if not True: split_986A8.operator_context = "EXEC_DEFAULT"
        split_986A8.prop(item_AE408, 'activ', text='', icon_value=(load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'KaFire_icon_0.png')[:int(len(os.path.join(os.path.dirname(__file__), 'assets', 'KaFire_icon_0.png')) - 5.0)] + str(item_AE408.icon) + '.png') if item_AE408.activ else _icons['KaFire_icon_inactiv.png'].icon_id), emboss=False)
        split_986A8.label(text=item_AE408.manipulator.name, icon_value=0)
        if item_AE408.has_torch_part:
            layout.prop(item_AE408, 'fire_part_visibility', text='', icon_value=(653 if item_AE408.fire_part_visibility else 654), emboss=False)
        row_19F17 = layout.row(heading='', align=False)
        row_19F17.alert = (not item_AE408.edit_lock)
        row_19F17.enabled = True
        row_19F17.active = True
        row_19F17.use_property_split = False
        row_19F17.use_property_decorate = False
        row_19F17.scale_x = 1.0
        row_19F17.scale_y = 1.0
        row_19F17.alignment = 'Expand'.upper()
        row_19F17.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_19F17.prop(item_AE408, 'edit_lock', text='', icon_value=(41 if item_AE408.edit_lock else 40), emboss=(not item_AE408.edit_lock))
        row_19F17.prop(item_AE408, 'fire_visibility', text='', icon_value=(_icons['toch_on.png'].icon_id if item_AE408.fire_visibility else _icons['toch_off.png'].icon_id), emboss=False)

    def filter_items(self, context, data, propname):
        flt_flags = []
        for item in getattr(data, propname):
            if not self.filter_name or self.filter_name.lower() in item.name.lower():
                if True:
                    flt_flags.append(self.bitflag_filter_item)
                else:
                    flt_flags.append(0)
            else:
                flt_flags.append(0)
        return flt_flags, []


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


def sna_update_activ_789A3(self, context):
    sna_updated_prop = self.activ
    manip = self.manipulator
    is_activ = sna_updated_prop
    for child in manip.children_recursive:
        if 'torch_mesh' in child.name:
            for mod in child.modifiers:
                if mod.type == 'FLUID':
                    mod.show_viewport = is_activ


def sna_update_fluid_absolute_density_E4ADC(self, context):
    sna_updated_prop = self.fluid_absolute_density
    manip = self.manipulator
    abs_density = sna_updated_prop
    for torch in manip.children_recursive:
        if 'torch_mesh' in torch.name:        
            try:
                torch.modifiers["KFluid"].flow_settings.use_absolute = abs_density
            except:
                print("Can't find KFluid modofier")


def sna_update_min_F24B2(self, context):
    sna_updated_prop = self.min
    sna_update_fire_CF4A5(self.manipulator, self, bpy.context.scene.sna_fire_index)


def sna_update_sna_kfire_angle_4CFE2(self, context):
    sna_updated_prop = self.sna_kfire_angle
    sna_update_fire_CF4A5(self, bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], bpy.context.scene.sna_fire_index)


def sna_update_ring_C3F9E(self, context):
    sna_updated_prop = self.ring
    sna_update_fire_CF4A5(self.manipulator, self, bpy.context.scene.sna_fire_index)


def sna_update_torch_part_emission_duration_B03E1(self, context):
    sna_updated_prop = self.torch_part_emission_duration
    if property_exists("self.particles_emitter", globals(), locals()):
        particles_emitter = self.particles_emitter
        num = sna_updated_prop
        time_offset = self.particle_time_offset
        if len(particles_emitter.particle_systems)>0:
            particles_emitter.particle_systems[0].settings.frame_end = particles_emitter.particle_systems[0].settings.frame_start + num


def sna_update_torch_part_number_1461B(self, context):
    sna_updated_prop = self.torch_part_number
    if property_exists("self.particles_emitter", globals(), locals()):
        particles_emitter = self.particles_emitter
        num = sna_updated_prop
        particles_emitter.particle_systems[0].settings.count = num


def sna_update_sna_fire_index_C5194(self, context):
    sna_updated_prop = self.sna_fire_index
    if ((bpy.context.scene.sna_fire_index != bpy.context.scene.sna_previous_fire_index) and property_exists("bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator", globals(), locals())):
        manip = bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator
        bpy.ops.object.select_all(action='DESELECT')
        manip.select_set(True)
        bpy.context.view_layer.objects.active = manip
        print(str(bpy.context.scene.sna_fire_index), '')
        bpy.context.scene.sna_previous_fire_index = bpy.context.scene.sna_fire_index


def sna_update_fire_part_visibility_911AB(self, context):
    sna_updated_prop = self.fire_part_visibility
    if property_exists("self.particles_emitter", globals(), locals()):
        manip = self.manipulator
        visible = sna_updated_prop
        if visible:
            for emitter in manip.children:
                if 'Fire_Particles_Emitter' in emitter.name:        
                    emitter.hide_viewport = False
        else:
            for emitter in manip.children:
                if 'Fire_Particles_Emitter' in emitter.name:
                    emitter.hide_viewport = True


def sna_update_fire_visibility_405D5(self, context):
    sna_updated_prop = self.fire_visibility
    manip = self.manipulator
    visible = sna_updated_prop
    if visible:
        for torch in manip.children:
            if 'Torch' in torch.name:        
                torch.hide_viewport = False
    else:
        for torch in manip.children:
            if 'Torch' in torch.name:
                torch.hide_viewport = True


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


def sna_rand_hexa_number_string_BE9A1_6EC5B(size):
    s = size
    out = None
    out = f'{random.randrange(16**size):x}'
    return out


def sna_move_outliner_collection_object_A90B9_337FB(object, collection_name):
    ob = object
    coll_name = collection_name
    object_old_coll = object.users_collection
    collection = bpy.data.collections.get( collection_name )
    if collection not in object_old_coll:
        if collection is None:
            collection = bpy.data.collections.new( collection_name )
            bpy.context.scene.collection.children.link( collection )
        collection.objects.link( object )
        for coll in object_old_coll:
            coll.objects.unlink(object)


def sna_rand_hexa_number_string_BE9A1_F204E(size):
    s = size
    out = None
    out = f'{random.randrange(16**size):x}'
    return out


_F6358_running = False
class SNA_OT_Draw_Image_Ui_F6358(bpy.types.Operator):
    bl_idname = "sna.draw_image_ui_f6358"
    bl_label = "draw_image_UI"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_image_file_path: bpy.props.StringProperty(name='image_file_path', description='', default='', subtype='NONE', maxlen=0)
    cursor = "STOP"
    _handle = None
    _event = {}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        if not True or context.area.spaces[0].bl_rna.identifier == 'SpaceView3D':
            return not False
        return False

    def save_event(self, event):
        event_options = ["type", "value", "alt", "shift", "ctrl", "oskey", "mouse_region_x", "mouse_region_y", "mouse_x", "mouse_y", "pressure", "tilt"]
        if bpy.app.version >= (3, 2, 1):
            event_options += ["type_prev", "value_prev"]
        for option in event_options: self._event[option] = getattr(event, option)

    def draw_callback_px(self, context):
        event = self._event
        if event.keys():
            event = dotdict(event)
            try:
                pass
            except Exception as error:
                print(error)

    def execute(self, context):
        global _F6358_running
        _F6358_running = False
        context.window.cursor_set("DEFAULT")
        bpy.types.SpaceView3D.draw_handler_remove(self._handle, 'WINDOW')
        if handler_961E1:
            bpy.types.SpaceView3D.draw_handler_remove(handler_961E1[0], 'WINDOW')
            handler_961E1.pop(0)
            for a in bpy.context.screen.areas: a.tag_redraw()
        bpy.ops.outliner.orphans_purge()
        for area in context.screen.areas:
            area.tag_redraw()
        return {"FINISHED"}

    def modal(self, context, event):
        global _F6358_running
        if not context.area or not _F6358_running:
            self.execute(context)
            return {'CANCELLED'}
        if not self._event:
            self._event = {}
        self.save_event(event)
        context.area.tag_redraw()
        context.window.cursor_set('STOP')
        try:
            pass
        except Exception as error:
            print(error)
        if event.type in ['RIGHTMOUSE', 'ESC']:
            self.execute(context)
            return {'CANCELLED'}
        return {'RUNNING_MODAL'}

    def invoke(self, context, event):
        self._event = {}
        global _F6358_running
        if _F6358_running:
            _F6358_running = False
            return {'FINISHED'}
        else:
            self.save_event(event)
            self.start_pos = (event.mouse_x, event.mouse_y)
            i_filepath = self.sna_image_file_path
            image = None
            img_width = None
            img_height = None
            image = bpy.data.images.load(i_filepath)
            img_width, img_height = image.size
            #image.source = 'FILE'
            #image.filepath = i_filepath
            handler_961E1.append(bpy.types.SpaceView3D.draw_handler_add(sna_draw_1AE07, (image, img_width, img_height, ), 'WINDOW', 'POST_PIXEL'))
            for a in bpy.context.screen.areas: a.tag_redraw()
            args = (context,)
            self._handle = bpy.types.SpaceView3D.draw_handler_add(self.draw_callback_px, args, 'WINDOW', 'POST_PIXEL')
            context.window_manager.modal_handler_add(self)
            _F6358_running = True
            return {'RUNNING_MODAL'}


import gpu
from gpu_extras.batch import batch_for_shader


def sna_get_ui_panels_widths_3D83C():
    tool_width = None
    ui_width = None
    for region in bpy.context.area.regions:
        if region.type == "TOOLS":
            tool_width = region.width
            break
    for region in bpy.context.area.regions:
        if region.type == "UI":
            ui_width = region.width
            break
    return [tool_width, ui_width]


def sna_draw_1AE07(p_image, img_w, img_h):
    tools_w_0_b5cd2, ui_w_1_b5cd2 = sna_get_ui_panels_widths_3D83C()
    image = p_image
    image_width = img_w
    image_height = img_h
    area_center_x = (region_by_type(bpy.context.area, 'WINDOW').width/2, region_by_type(bpy.context.area, 'WINDOW').height/2)[0]
    area_center_y = (region_by_type(bpy.context.area, 'WINDOW').width/2, region_by_type(bpy.context.area, 'WINDOW').height/2)[1]
    area_tools_width = tools_w_0_b5cd2
    area_ui_width = ui_w_1_b5cd2
    center_x = (2 * area_center_x - area_ui_width - area_tools_width) / 2 + area_tools_width
    x1 = center_x - image_width/2
    x2 = center_x + image_width/2 
    y1 = area_center_y - image_height/2
    y2 = area_center_y + image_height/2
    shader = gpu.shader.from_builtin('IMAGE')
    batch = batch_for_shader(
        shader, 'TRI_FAN',
        {
            "pos": ((x1, y1), (x2, y1), (x2, y2), (x1, y2)),
            "texCoord": ((0, 0), (1, 0), (1, 1), (0, 1)),
        },
    )
    if image.gl_load():
        raise Exception()
    gpu.state.blend_set('ALPHA')
    texture = gpu.texture.from_image(image)
    shader.bind()
    shader.uniform_sampler("image", texture)
    batch.draw(shader)
    image.gl_free()


def sna_is_smoke_domain_CCB37(object):
    ob = object
    out = None
    if len(bpy.context.selected_objects[:])>0 and ob.modifiers:
        m = ob.modifiers
        out = False
        if len(m) > 0:
            if m[0].type == 'FLUID':
                if m[0].fluid_type == 'DOMAIN':
                    out = True
    return out


def sna_selected_object_is_kfire_DD909(object):
    ob = object
    out = None
    index = None
    out = False
    for index in range(len(bpy.context.scene.sna_fire_col)):
        kfire = bpy.context.scene.sna_fire_col[index]
        if kfire.manipulator == ob:
            if index == bpy.context.scene.sna_fire_index:
                out = False
                break
            else:
                out = True
                break  
    return [out, index]


def sna_selected_object_is_already_kfire_FFA5A(object):
    ob = object
    out = None
    out = False
    for k in bpy.context.scene.sna_fire_col:
        if k.manipulator == ob:
            out = True
            break
    return out


class SNA_OT_Kfop_Select_Active_Kafire_684Cf(bpy.types.Operator):
    bl_idname = "sna.kfop_select_active_kafire_684cf"
    bl_label = "KfOp_Select_Active_KaFire"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        ob = bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator
        bpy.ops.object.select_all(action='DESELECT')
        try:
            ob.select_set(True)
            bpy.context.view_layer.objects.active = ob
        except:
            pass
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Remove_Fire_Ba54A(bpy.types.Operator):
    bl_idname = "sna.remove_fire_ba54a"
    bl_label = "Remove_Fire"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_index_tmp: bpy.props.IntProperty(name='index_tmp', description='', default=0, subtype='NONE')

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        manip = bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator
        try:
            for child in manip.children_recursive:
                bpy.data.objects.remove(child)
        except:
            print("No children found")
        try:
            bpy.data.objects.remove(manip)
        except:
            print("No manipulator found")
        if len(bpy.context.scene.sna_fire_col) > bpy.context.scene.sna_fire_index:
            bpy.context.scene.sna_fire_col.remove(bpy.context.scene.sna_fire_index)
        if (len(bpy.context.scene.sna_fire_col) > 0):
            bpy.context.scene.sna_fire_index = int(eval("max(0.0,int(bpy.context.scene.sna_fire_index - 1.0))"))
            sna_select_object_63C82(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator)
        else:
            try:
                bpy.context.view_layer.objects.active = bpy.context.view_layer.objects[0]
            except:
                self.report({'INFO'}, message='No object in the scene')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Fire_Create_E4Cc2(bpy.types.Operator):
    bl_idname = "sna.fire_create_e4cc2"
    bl_label = "Fire_Create"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_new_icon: bpy.props.BoolProperty(name='new_icon', description='', default=False)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        col_len = len(bpy.context.scene.sna_fire_col)
        kfire_col = bpy.context.scene.sna_fire_col
        is_new_icon = self.sna_new_icon
        out = None
        if col_len > 0:
            out = kfire_col[col_len-1].icon
            current_icon = kfire_col[bpy.context.scene.sna_fire_index].icon
        else:
            out = -1
            current_icon = 0
        out = random.randint(0,6)    
        #out += 3
        #out = out%7
        if is_new_icon:
            if out == current_icon:
                out += 1
            else:
                out = out
        else:
            out = current_icon
        sna_add_fire_12BE5(out)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_fn_remove_object_370A3(object):
    ob = object
    bpy.data.objects.remove(ob)


def sna_update_particles_fluid_FE78F(is_update, particles_emitter, col_item_name):
    update = is_update
    emitter = particles_emitter
    col_name = col_item_name
    if 1==0:
        pass
    else:
        #################################################### create fluid MODIFIER
        emitter.modifiers.new('KFire_Paticles_Fluid','FLUID')
        emitter.modifiers["KFire_Paticles_Fluid"].fluid_type = 'FLOW'
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.flow_behavior = 'INFLOW'
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.flow_source = 'PARTICLES'
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.particle_system = emitter.particle_systems[0]
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.flow_type = 'BOTH'
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.volume_density = 0
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.temperature = 1.0
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.use_absolute = False
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.particle_size = 1
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.use_initial_velocity = False
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.velocity_factor = 0
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.velocity_normal = 0
        emitter.modifiers["KFire_Paticles_Fluid"].flow_settings.subframes = 5
        #color smoke
        color_driver = emitter.driver_add('modifiers["KFire_Paticles_Fluid"].flow_settings.smoke_color')
        color_driver[0].driver.type='SCRIPTED'
        color_var = color_driver[0].driver.variables.new()
        color_var.name = 'color'
        color_var.targets[0].id_type = 'SCENE'
        color_var.targets[0].id = bpy.context.scene
        color_var.targets[0].data_path = 'sna_fire_col["' + col_name + '"].fire_smoke_color.r'
        color_driver[0].driver.expression = 'pow(color,1/2.2)'
        color_driver[1].driver.type='SCRIPTED'
        color_var = color_driver[1].driver.variables.new()
        color_var.name = 'color'
        color_var.targets[0].id_type = 'SCENE'
        color_var.targets[0].id = bpy.context.scene
        color_var.targets[0].data_path = 'sna_fire_col["' + col_name + '"].fire_smoke_color.g'
        color_driver[1].driver.expression = 'pow(color,1/2.2)'
        color_driver[2].driver.type='SCRIPTED'
        color_var = color_driver[2].driver.variables.new()
        color_var.name = 'color'
        color_var.targets[0].id_type = 'SCENE'
        color_var.targets[0].id = bpy.context.scene
        color_var.targets[0].data_path = 'sna_fire_col["' + col_name + '"].fire_smoke_color.b'
        color_driver[2].driver.expression = 'pow(color,1/2.2)'
        #particle size:
        part_size_driver = emitter.driver_add('modifiers["KFire_Paticles_Fluid"].flow_settings.particle_size')
        part_size_driver.driver.type='SCRIPTED'
        color_var = part_size_driver.driver.variables.new()
        color_var.name = 'size'
        color_var.targets[0].id_type = 'SCENE'
        color_var.targets[0].id = bpy.context.scene
        color_var.targets[0].data_path = 'sna_fire_col["' + col_name + '"].particles_emitter["Kfire_smoke_particles_size"]'
        part_size_driver.driver.expression = 'size'


class SNA_OT_Create_Kafire_Domain_1Ba2A(bpy.types.Operator):
    bl_idname = "sna.create_kafire_domain_1ba2a"
    bl_label = "Create_Kafire_domain"
    bl_description = "Create Smoke Domain For KaFires"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        ka_fire_domain = None
        if len(bpy.context.selected_objects) > 0:
            domain_loc = bpy.context.selected_objects[0].location
        else:
            domain_loc = bpy.context.scene.cursor.location
        cursor_matrix = bpy.context.scene.cursor.matrix
        bpy.ops.object.select_all(action='DESELECT')
        bpy.ops.mesh.primitive_cube_add(size=2, enter_editmode=False, align='WORLD', location=(domain_loc.x, domain_loc.y, domain_loc.z + 0.96), scale=(1, 1, 1))
        #change object pivot#########################
        obj = bpy.context.active_object
        bpy.ops.object.mode_set(mode = 'EDIT') 
        bpy.ops.mesh.select_mode(type="FACE")
        bpy.ops.mesh.select_all(action = 'DESELECT')
        bpy.ops.object.mode_set(mode = 'OBJECT')
        obj.data.polygons[4].select = True
        obj.data.polygons.active = 4
        bpy.ops.object.mode_set(mode = 'EDIT') 
        bpy.ops.view3d.snap_cursor_to_selected()
        bpy.ops.object.mode_set(mode = 'OBJECT')
        bpy.ops.object.origin_set(type='ORIGIN_CURSOR', center='MEDIAN')
        bpy.context.scene.cursor.matrix = cursor_matrix
        ###########################################
        ka_fire_domain = bpy.context.object
        ka_fire_domain.name = 'KaFire_Domain'
        bpy.ops.object.modifier_add(type='FLUID')
        bpy.context.object.modifiers["Fluid"].name = "KaFluid"
        ka_fire_domain.modifiers[0].fluid_type = 'DOMAIN'
        ka_fire_domain.modifiers["KaFluid"].domain_settings.resolution_max = 64
        ka_fire_domain.modifiers["KaFluid"].domain_settings.timesteps_min = 2
        ka_fire_domain.modifiers["KaFluid"].domain_settings.use_dissolve_smoke = True
        ka_fire_domain.modifiers["KaFluid"].domain_settings.dissolve_speed = 50
        ka_fire_domain.modifiers["KaFluid"].domain_settings.use_adaptive_domain = True
        ka_fire_domain.modifiers["KaFluid"].domain_settings.cache_frame_start = bpy.context.scene.frame_start
        ka_fire_domain.modifiers["KaFluid"].domain_settings.cache_frame_end = bpy.context.scene.frame_end
        ka_fire_domain.modifiers["KaFluid"].domain_settings.use_adaptive_domain = False
        ka_fire_domain.modifiers["KaFluid"].domain_settings.alpha = 1 # buoyancy density
        ka_fire_domain.modifiers["KaFluid"].domain_settings.beta = 1  # Heat
        ka_fire_domain.modifiers["KaFluid"].domain_settings.use_noise = False
        ka_fire_domain.modifiers["KaFluid"].domain_settings.delete_in_obstacle = False
        ka_fire_domain.modifiers["KaFluid"].domain_settings.use_collision_border_bottom = True
        ka_fire_domain.modifiers["KaFluid"].domain_settings.display_thickness = 10.0
        ############################## ADD SMOKE MATERIAL
        new_mat = bpy.data.materials.get('Ka_Fire_Material')
        if not new_mat:
            new_mat = bpy.data.materials.new('Ka_Fire_Material')
            new_mat.use_nodes = True
            node_tree = new_mat.node_tree
            nodes = node_tree.nodes
            nodes.clear()
            links = node_tree.links
            links.clear()
        # Nodes :
            new_node = nodes.new(type='NodeFrame')
            new_node.color = (1.0, 0.6666667461395264, 5.3551048040390015e-09)
            new_node.label_size = 20
            new_node.location = (0.0, 36.95432662963867)
            new_node.name = 'Frame'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.use_custom_color = True
            new_node.width = 200.27908325195312
            new_node = nodes.new(type='ShaderNodeOutputMaterial')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.is_active_output = True
            new_node.location = (1065.8270263671875, 389.4327087402344)
            new_node.name = 'Material Output'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.target = 'ALL'
            new_node.width = 140.0
            new_node.inputs[2].default_value = [0.0, 0.0, 0.0]
            new_node.inputs[3].default_value = 0.0
            new_node = nodes.new(type='ShaderNodeVolumePrincipled')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.location = (691.7501220703125, 352.21661376953125)
            new_node.name = 'Principled Volume'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.width = 303.580810546875
            new_node.inputs[0].default_value = [0.5, 0.37445971369743347, 0.20905278623104095, 1.0]
            #new_node.inputs[1].default_value = 
            new_node.inputs[2].default_value = 10.0
            new_node.inputs[3].default_value = 'density'
            new_node.inputs[4].default_value = 0.0
            new_node.inputs[5].default_value = [0.11406838148832321, 0.11406838148832321, 0.11406838148832321, 1.0]
            new_node.inputs[6].default_value = 0.0
            new_node.inputs[7].default_value = [1.0, 0.11472676694393158, 0.0, 1.0]
            new_node.inputs[8].default_value = 1.0
            new_node.inputs[9].default_value = [0.0, 0.0, 0.0, 0.0]
            new_node.inputs[10].default_value = 2500.0
            new_node.inputs[11].default_value = 'temperature'
            new_node.inputs[12].default_value = 0.0
            new_node = nodes.new(type='ShaderNodeVolumeInfo')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.location = (-287.5863952636719, 331.24786376953125)
            new_node.name = 'Volume Info'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.width = 140.0
            new_node.outputs[0].default_value = [0.0, 0.0, 0.0, 0.0]
            new_node.outputs[1].default_value = 0.0
            new_node.outputs[2].default_value = 0.0
            new_node.outputs[3].default_value = 0.0
            new_node = nodes.new(type='ShaderNodeBlackbody')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.location = (230.6161651611328, 59.3228645324707)
            new_node.name = 'Blackbody'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.width = 221.18048095703125
            new_node.inputs[0].default_value = 1200.0
            new_node.outputs[0].default_value = [0.0, 0.0, 0.0, 0.0]
            new_node = nodes.new(type='ShaderNodeValue')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.label = 'Smoke Density'
            new_node.location = (-287.4158935546875, 525.01025390625)
            new_node.name = 'Ka_Smoke_Density'
            parent = nodes.get('Frame')
            if parent:
                new_node.parent = parent
                while True:
                    new_node.location += parent.location
                    if parent.parent:
                        parent = parent.parent
                    else:
                        break                    
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.width = 140.0
            new_node.outputs[0].default_value = 10.0
            new_node = nodes.new(type='ShaderNodeMath')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.hide = True
            new_node.location = (426.3950500488281, 165.88934326171875)
            new_node.name = 'Math'
            new_node.operation = 'MULTIPLY'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.use_clamp = False
            new_node.width = 140.0
            new_node.inputs[0].default_value = 0.5
            new_node.inputs[1].default_value = 6.400001525878906
            new_node.inputs[2].default_value = 0.5
            new_node.outputs[0].default_value = 0.0
            new_node = nodes.new(type='ShaderNodeValue')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.label = 'Flame Intensity'
            new_node.location = (-287.06610107421875, 430.23565673828125)
            new_node.name = 'Ka_Flame_Intensity'
            parent = nodes.get('Frame')
            if parent:
                new_node.parent = parent
                while True:
                    new_node.location += parent.location
                    if parent.parent:
                        parent = parent.parent
                    else:
                        break                    
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.width = 140.0
            new_node.outputs[0].default_value = 6.0
            new_node = nodes.new(type='ShaderNodeGamma')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.hide = True
            new_node.location = (232.64906311035156, 250.3064727783203)
            new_node.name = 'Gamma'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.width = 140.0
            new_node.inputs[0].default_value = [1.0, 1.0, 1.0, 1.0]
            new_node.inputs[1].default_value = 0.45500001311302185
            new_node.outputs[0].default_value = [0.0, 0.0, 0.0, 0.0]
            new_node = nodes.new(type='ShaderNodeMath')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.hide = True
            new_node.location = (228.21795654296875, 203.13746643066406)
            new_node.name = 'Math.001'
            new_node.operation = 'POWER'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.use_clamp = False
            new_node.width = 140.0
            new_node.inputs[0].default_value = 0.5
            new_node.inputs[1].default_value = 3.5
            new_node.inputs[2].default_value = 0.5
            new_node.outputs[0].default_value = 0.0
            new_node = nodes.new(type='ShaderNodeMath')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.hide = True
            new_node.location = (238.6519775390625, 102.67527770996094)
            new_node.name = 'Math.002'
            new_node.operation = 'MULTIPLY'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.use_clamp = False
            new_node.width = 140.0
            new_node.inputs[0].default_value = 0.5
            new_node.inputs[1].default_value = 6.400001525878906
            new_node.inputs[2].default_value = 0.5
            new_node.outputs[0].default_value = 0.0
            new_node = nodes.new(type='ShaderNodeMath')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.hide = True
            new_node.location = (232.30824279785156, 152.9016876220703)
            new_node.name = 'Math.003'
            new_node.operation = 'EXPONENT'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.use_clamp = False
            new_node.width = 140.0
            new_node.inputs[0].default_value = 0.5
            new_node.inputs[1].default_value = 6.400001525878906
            new_node.inputs[2].default_value = 0.5
            new_node.outputs[0].default_value = 0.0
            new_node = nodes.new(type='NodeReroute')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.location = (64.22611999511719, 103.15665435791016)
            new_node.name = 'Reroute'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.width = 16.0
            new_node = nodes.new(type='NodeReroute')
            new_node.color = (0.6079999804496765, 0.6079999804496765, 0.6079999804496765)
            new_node.location = (67.68557739257812, 148.5946044921875)
            new_node.name = 'Reroute.001'
            new_node.select = False
            try:
                new_node.status = False
            except:
                pass
            new_node.width = 16.0
            # Links :
            links.new(nodes["Math.002"].outputs[0], nodes["Principled Volume"].inputs[8])    
            links.new(nodes["Volume Info"].outputs[0], nodes["Gamma"].inputs[0])    
            links.new(nodes["Volume Info"].outputs[2], nodes["Reroute"].inputs[0])    
            links.new(nodes["Gamma"].outputs[0], nodes["Principled Volume"].inputs[5])    
            links.new(nodes["Volume Info"].outputs[0], nodes["Principled Volume"].inputs[0])    
            links.new(nodes["Ka_Smoke_Density"].outputs[0], nodes["Principled Volume"].inputs[2])    
            links.new(nodes["Principled Volume"].outputs[0], nodes["Material Output"].inputs[1])    
            links.new(nodes["Blackbody"].outputs[0], nodes["Principled Volume"].inputs[7])    
            links.new(nodes["Reroute"].outputs[0], nodes["Math.002"].inputs[0])    
            links.new(nodes["Reroute.001"].outputs[0], nodes["Math.002"].inputs[1])    
            links.new(nodes["Volume Info"].outputs[2], nodes["Math.001"].inputs[0])    
            links.new(nodes["Math.001"].outputs[0], nodes["Math"].inputs[0])    
            links.new(nodes["Math"].outputs[0], nodes["Principled Volume"].inputs[6])    
            links.new(nodes["Reroute.001"].outputs[0], nodes["Math.003"].inputs[0])    
            links.new(nodes["Math.003"].outputs[0], nodes["Math"].inputs[1])    
            links.new(nodes["Ka_Flame_Intensity"].outputs[0], nodes["Reroute.001"].inputs[0])    
        ka_fire_domain.data.materials.append(new_mat)
        sna_move_outliner_collection_object_A90B9_7CA1B(ka_fire_domain, 'KaFire_Domains')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Add_Fire_Particles_1Eb21(bpy.types.Operator):
    bl_idname = "sna.add_fire_particles_1eb21"
    bl_label = "Add_Fire_Particles"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_col_index: bpy.props.IntProperty(name='col_index', description='', default=0, subtype='NONE')
    sna_update: bpy.props.BoolProperty(name='update', description='', default=False)
    sna_to_all_kafires: bpy.props.BoolProperty(name='to_all_kafires', description='', default=False)
    sna_to_kafire_group: bpy.props.BoolProperty(name='to_kafire_group', description='', default=False)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if self.sna_update:
            pass
        else:
            if self.sna_to_all_kafires:
                for i_B6298 in range(len(bpy.context.scene.sna_fire_col)):
                    if bpy.context.scene.sna_fire_col[i_B6298].has_torch_part:
                        pass
                    else:
                        sna_add_fire_particles_emitter_DB377(bpy.context.scene.sna_fire_col[i_B6298], i_B6298)
                        bpy.ops.sna.add_fire_particles_1eb21('INVOKE_DEFAULT', sna_col_index=i_B6298, sna_update=True, sna_to_all_kafires=False, sna_to_kafire_group=False)
                        bpy.context.scene.sna_fire_col[i_B6298].has_torch_part = True
            else:
                if self.sna_to_kafire_group:
                    for i_30D0A in range(len(bpy.context.scene.sna_fire_col)):
                        if ((bpy.context.scene.sna_fire_col[i_30D0A].manipulator['kfire_id'] == list(bpy.context.scene.sna_fire_col)[self.sna_col_index].manipulator['kfire_id']) and (not bpy.context.scene.sna_fire_col[i_30D0A].has_torch_part)):
                            sna_add_fire_particles_emitter_DB377(bpy.context.scene.sna_fire_col[i_30D0A], i_30D0A)
                            bpy.ops.sna.add_fire_particles_1eb21('INVOKE_DEFAULT', sna_col_index=i_30D0A, sna_update=True, sna_to_all_kafires=False, sna_to_kafire_group=False)
                            bpy.context.scene.sna_fire_col[i_30D0A].has_torch_part = True
                else:
                    sna_add_fire_particles_emitter_DB377(list(bpy.context.scene.sna_fire_col)[self.sna_col_index], self.sna_col_index)
                    list(bpy.context.scene.sna_fire_col)[self.sna_col_index].has_torch_part = True
        fire_item = list(bpy.context.scene.sna_fire_col)[self.sna_col_index]
        fire_index = self.sna_col_index
        out = None
        ###################################----------------------------DEBUG----------------
        # DEBUG----------------------------------------------
        #    text.write(debug('len torch part=',len(list_torch_particles)))
        #----------------------------------------------------  
        try:
            text = bpy.data.texts['Debug']
            text.clear()
        except:
            bpy.data.texts.new('Debug')

        def debug(*args):
            msg = ''
            for a in args:
                msg+=str(a)
            msg += '\n'
            return msg
        ####################################### --------------------- DEBUG -------------["Kfire_density"]

        def setup_drivers(item_index, object, dict):
            for path, var_path in dict.items():
                driver = object.driver_add(path)
                driver.driver.type="AVERAGE" 
                newvar = driver.driver.variables.new()
                newvar.name = var_path     
                newvar.targets[0].id_type = 'OBJECT'
                newvar.targets[0].id = bpy.context.scene.sna_fire_col[item_index].particles_emitter                 
                newvar.targets[0].data_path = '["' + var_path + '"]'
        manip = fire_item.manipulator
        threshold = fire_item.torch_part_thresold
        number_part = fire_item.torch_part_number
        duration_part = fire_item.torch_part_emission_duration
        life_part = fire_item.torch_part_life
        speed_part = fire_item.torch_part_speed
        emitter = fire_item.particles_emitter
        out = False
        try:
            if manip.animation_data.action:
                for fcu in manip.animation_data.action.fcurves:
                    if fcu.data_path == '["Kfire_emission"]':
                        break
                    else:
                        fcu = None
            else:
                fcu = None
        except:
            fcu = None
        if fcu:    
            for m in emitter.modifiers:
                if 'KFire_Parts_' in m.name:
                    emitter.modifiers.remove(m)
            sys_num = 0
            for p in fcu.keyframe_points:
                if p.co.y >= threshold:
                    out = True               
                    modifier_name = 'KFire_Parts_' + str(sys_num)
                    ps = emitter.modifiers.new(modifier_name, 'PARTICLE_SYSTEM')
                    psys = emitter.particle_systems[ps.name]
                    #bpy.data.particles["ParticleSettings"].name = 'fire_part_settings'
                    psys.settings.frame_start = int(p.co.x) - 1
                    psys.settings.frame_end = int(p.co.x) - 1 + duration_part#psys.settings.frame_start + duration + rand
                    psys.settings.count = number_part
                    psys.settings.distribution = 'RAND'
                    psys.settings.object_factor = 1
                    psys.settings.use_modifier_stack = True
                    psys.settings.use_rotations = False
                    psys.settings.particle_size = 0.2
                    psys.settings.size_random = 4
                    psys.settings.lifetime = life_part   
                    psys.seed = int(random.uniform(1,200))
                    #psys.settings.render_type = 'COLLECTION'
                    #psys.settings.instance_collection = part_collection
                    #psys.settings.use_collection_pick_random = True
                    psys.settings.object_factor = 0
                    psys.settings.factor_random = 0.1
                    #psys.settings.normal_factor = speed_part
                    #psys.settings.object_align_factor.z = speed_part * torch.empty_display_size
                    #psys.settings.damping = .2 
                    psys.settings.display_size = .02
                    #psys.settings.effector_weights.gravity = random.uniform(0.5,1.5)
                    psys.settings.effector_weights.all = 0.0
                    emitter.show_instancer_for_render = False
                    drivers_path = {
                    'lifetime' : 'Kfire_particles_life',
                    'normal_factor' : 'Kfire_particles_speed',
                    'factor_random' : 'Kfire_particles_random',
                    'lifetime_random' : 'Kfire_particles_random', 
                    'damping' : 'Kfire_particles_damping'
                    }
                    setup_drivers(fire_index, psys.settings, drivers_path)
                    break
        if out:
            sna_update_particles_fluid_FE78F(self.sna_update, list(bpy.context.scene.sna_fire_col)[self.sna_col_index].particles_emitter, bpy.context.scene.sna_fire_col[self.sna_col_index].name)
        else:
            bpy.ops.sna.remove_particles_0a771('INVOKE_DEFAULT', )
            self.report({'INFO'}, message='No Particles (Threshold too high or No Emission Keyframe)')
        sna_select_object_63C82(list(bpy.context.scene.sna_fire_col)[self.sna_col_index].manipulator)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Actualise_Index_From_Selection_7260C(bpy.types.Operator):
    bl_idname = "sna.actualise_index_from_selection_7260c"
    bl_label = "actualise index from selection"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_index: bpy.props.IntProperty(name='index', description='', default=0, subtype='NONE')

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.context.scene.sna_fire_index = self.sna_index
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_add_fire_particles_emitter_DB377(fire_item, fire_col_index):
    if property_exists("bpy.data.node_groups['*Fire_Particle_Emitter*']", globals(), locals()):
        pass
    else:
        before_data = list(bpy.data.node_groups)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KaFire_Assets_0.1.04.blend') + r'\NodeTree', filename='*Fire_Particle_Emitter*', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.node_groups)))
        appended_78F14 = None if not new_data else new_data[0]
        appended_78F14.use_fake_user = True
    before_data = list(bpy.data.objects)
    bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KaFire_Assets_0.1.04.blend') + r'\Object', filename='KFire_Parts_Emitter', link=False)
    new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
    appended_7D1FC = None if not new_data else new_data[0]
    sna_move_outliner_collection_object_A90B9_61FC7(appended_7D1FC, 'KaFires')
    appended_7D1FC.parent = fire_item.manipulator
    object = appended_7D1FC
    node_tree = bpy.data.node_groups['*Fire_Particle_Emitter*']
    fire_index = fire_col_index
    geo_mod = object.modifiers.new('geo_fire_emitter','NODES')
    geo_mod.node_group = node_tree
    angle_driver = object.driver_add('modifiers["geo_fire_emitter"]["Input_2"]')
    angle_driver.driver.type="SCRIPTED" 
    angle_var = angle_driver.driver.variables.new()
    angle_var.name = 'angle'     
    angle_var.targets[0].id_type = 'OBJECT'
    angle_var.targets[0].id = bpy.context.scene.sna_fire_col[fire_index].manipulator              
    angle_var.targets[0].data_path = 'sna_kfire_angle'
    offset_var = angle_driver.driver.variables.new()
    offset_var.name = 'offset'     
    offset_var.targets[0].id_type = 'OBJECT'
    offset_var.targets[0].id = object                  
    offset_var.targets[0].data_path = 'sna_kfire_angle_offset'
    angle_driver.driver.expression = 'angle + offset'
    fire_item.particles_emitter = appended_7D1FC


class SNA_OT_Kfop_Set_Particles_Time_Offset_0034C(bpy.types.Operator):
    bl_idname = "sna.kfop_set_particles_time_offset_0034c"
    bl_label = "KfOp_Set_Particles_Time_Offset"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_offset: bpy.props.IntProperty(name='offset', description='', default=0, subtype='NONE', min=-20, max=20)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        particles_emitter = bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].particles_emitter
        time_offset = self.sna_offset
        particles_emitter.particle_systems[0].settings.frame_start += time_offset
        particles_emitter.particle_systems[0].settings.frame_end += time_offset
        return {"FINISHED"}

    def draw(self, context):
        layout = self.layout
        layout.label(text='Frames Offset', icon_value=118)
        layout.prop(self, 'sna_offset', text='', icon_value=0, emboss=True, slider=True)

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self, width=300)


class SNA_PT_KAFIRE_5EF18(bpy.types.Panel):
    bl_label = 'KaFire'
    bl_idname = 'SNA_PT_KAFIRE_5EF18'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'FRACTURE'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout
        layout.label(text='', icon_value=_icons['KaFire_icon.png'].icon_id)

    def draw(self, context):
        layout = self.layout
        if sna_is_smoke_domain_CCB37(bpy.context.view_layer.objects.active):
            row_7C52C = layout.row(heading='', align=False)
            row_7C52C.alert = bpy.context.scene.sna_fire_manta_replay
            row_7C52C.enabled = True
            row_7C52C.active = True
            row_7C52C.use_property_split = False
            row_7C52C.use_property_decorate = False
            row_7C52C.scale_x = 1.0
            row_7C52C.scale_y = 1.0
            row_7C52C.alignment = 'Expand'.upper()
            row_7C52C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_7C52C.operator('sna.mantaflow_replay_c30d8', text='Replay', icon_value=191, emboss=True, depress=bpy.context.scene.sna_fire_manta_replay)
        box_47D73 = layout.box()
        box_47D73.alert = False
        box_47D73.enabled = True
        box_47D73.active = True
        box_47D73.use_property_split = False
        box_47D73.use_property_decorate = False
        box_47D73.alignment = 'Expand'.upper()
        box_47D73.scale_x = 1.0
        box_47D73.scale_y = 1.0
        if not True: box_47D73.operator_context = "EXEC_DEFAULT"
        row_6DFC0 = box_47D73.row(heading='', align=False)
        row_6DFC0.alert = False
        row_6DFC0.enabled = True
        row_6DFC0.active = True
        row_6DFC0.use_property_split = True
        row_6DFC0.use_property_decorate = False
        row_6DFC0.scale_x = 1.0
        row_6DFC0.scale_y = 1.0
        row_6DFC0.alignment = 'Expand'.upper()
        row_6DFC0.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        coll_id = display_collection_id('AE408', locals())
        row_6DFC0.template_list('SNA_UL_display_collection_list_AE408', coll_id, bpy.context.scene, 'sna_fire_col', bpy.context.scene, 'sna_fire_index', rows=3)
        col_744CC = row_6DFC0.column(heading='', align=False)
        col_744CC.alert = False
        col_744CC.enabled = True
        col_744CC.active = True
        col_744CC.use_property_split = False
        col_744CC.use_property_decorate = False
        col_744CC.scale_x = 1.0
        col_744CC.scale_y = 1.0
        col_744CC.alignment = 'Expand'.upper()
        col_744CC.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = col_744CC.operator('sna.fire_create_e4cc2', text='', icon="ADD", emboss=True, depress=False)
        op.sna_new_icon = True
        col_804EC = col_744CC.column(heading='', align=False)
        col_804EC.alert = False
        col_804EC.enabled = (bpy.context.scene.sna_fire_index < len(bpy.context.scene.sna_fire_col))
        col_804EC.active = (bpy.context.scene.sna_fire_index < len(bpy.context.scene.sna_fire_col))
        col_804EC.use_property_split = False
        col_804EC.use_property_decorate = False
        col_804EC.scale_x = 1.0
        col_804EC.scale_y = 1.0
        col_804EC.alignment = 'Expand'.upper()
        col_804EC.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = col_804EC.operator('sna.remove_fire_ba54a', text='', icon="REMOVE", emboss=True, depress=False)
        op.sna_index_tmp = 0
        op = col_804EC.operator('sna.clone_kfire_38074', text='', icon="DUPLICATE", emboss=True, depress=False)
        op.sna_col_index = bpy.context.scene.sna_fire_index
        op = col_804EC.operator('sna.throw_dice_d5632', text='', icon_value=_icons['dices_icon.png'].icon_id, emboss=True, depress=False)
        op.sna_col_index = bpy.context.scene.sna_fire_index
        if sna_selected_object_is_kfire_DD909(bpy.context.view_layer.objects.active)[0]:
            row_3336C = col_804EC.row(heading='', align=False)
            row_3336C.alert = True
            row_3336C.enabled = True
            row_3336C.active = True
            row_3336C.use_property_split = True
            row_3336C.use_property_decorate = False
            row_3336C.scale_x = 1.0
            row_3336C.scale_y = 1.0
            row_3336C.alignment = 'Expand'.upper()
            row_3336C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_3336C.operator('sna.actualise_index_from_selection_7260c', text='', icon_value=614, emboss=True, depress=False)
            op.sna_index = sna_selected_object_is_kfire_DD909(bpy.context.view_layer.objects.active)[1]
        if (len(bpy.context.view_layer.objects.selected) > 0):
            box_26151 = box_47D73.box()
            box_26151.alert = False
            box_26151.enabled = property_exists("bpy.context.view_layer.objects.active['kfire_id']", globals(), locals())
            box_26151.active = property_exists("bpy.context.view_layer.objects.active['kfire_id']", globals(), locals())
            box_26151.use_property_split = False
            box_26151.use_property_decorate = False
            box_26151.alignment = 'Expand'.upper()
            box_26151.scale_x = 1.0
            box_26151.scale_y = 1.0
            if not True: box_26151.operator_context = "EXEC_DEFAULT"
            if property_exists("bpy.context.view_layer.objects.active['kfire_id']", globals(), locals()):
                row_71775 = box_26151.row(heading='', align=False)
                row_71775.alert = False
                row_71775.enabled = True
                row_71775.active = True
                row_71775.use_property_split = True
                row_71775.use_property_decorate = True
                row_71775.scale_x = 1.0
                row_71775.scale_y = 1.5
                row_71775.alignment = 'Expand'.upper()
                row_71775.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_71775.operator('sna.draw_image_ui_f6358', text='', icon_value=1, emboss=True, depress=False)
                op.sna_image_file_path = os.path.join(os.path.dirname(__file__), 'assets', 'kfire_emission_values_help.png')
                attr_156B8 = '["' + str('Kfire_emission' + '"]') 
                row_71775.prop(bpy.context.view_layer.objects.active, attr_156B8, text='Emission', icon_value=0, emboss=True, expand=True)
                op = row_71775.operator('sna.create_emission_keyframes_5492a', text='', icon_value=93, emboss=True, depress=False)
        if ((len(bpy.context.view_layer.objects.selected) > 0) and sna_selected_object_is_already_kfire_FFA5A(bpy.context.view_layer.objects.active)):
            pass
        else:
            if (len(bpy.context.scene.sna_fire_col) > 0):
                row_3D46F = box_47D73.row(heading='', align=False)
                row_3D46F.alert = True
                row_3D46F.enabled = True
                row_3D46F.active = True
                row_3D46F.use_property_split = False
                row_3D46F.use_property_decorate = False
                row_3D46F.scale_x = 1.0
                row_3D46F.scale_y = 1.0
                row_3D46F.alignment = 'Expand'.upper()
                row_3D46F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_3D46F.operator('sna.kfop_select_active_kafire_684cf', text='Select Active KaFire', icon_value=256, emboss=True, depress=False)
        if ((len(bpy.context.scene.sna_fire_col) > 0) and bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].edit_lock):
            col_C329C = box_47D73.column(heading='', align=False)
            col_C329C.alert = False
            col_C329C.enabled = True
            col_C329C.active = True
            col_C329C.use_property_split = False
            col_C329C.use_property_decorate = False
            col_C329C.scale_x = 1.0
            col_C329C.scale_y = 1.0
            col_C329C.alignment = 'Expand'.upper()
            col_C329C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            if ((len(bpy.context.scene.sna_fire_col) > 0) and bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].edit_lock):
                row_AD1AF = col_C329C.row(heading='', align=False)
                row_AD1AF.alert = False
                row_AD1AF.enabled = True
                row_AD1AF.active = True
                row_AD1AF.use_property_split = False
                row_AD1AF.use_property_decorate = False
                row_AD1AF.scale_x = 1.0
                row_AD1AF.scale_y = 1.0
                row_AD1AF.alignment = 'Expand'.upper()
                row_AD1AF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_AD1AF.label(text='Emitter:', icon_value=0)
                row_738EE = row_AD1AF.row(heading='', align=False)
                row_738EE.alert = False
                row_738EE.enabled = True
                row_738EE.active = True
                row_738EE.use_property_split = False
                row_738EE.use_property_decorate = False
                row_738EE.scale_x = 1.0
                row_738EE.scale_y = 1.0
                row_738EE.alignment = 'Right'.upper()
                row_738EE.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_738EE.template_icon(icon_value=_icons['toch_on.png'].icon_id, scale=1.5)
            col_C1334 = col_C329C.column(heading='', align=True)
            col_C1334.alert = False
            col_C1334.enabled = True
            col_C1334.active = True
            col_C1334.use_property_split = False
            col_C1334.use_property_decorate = False
            col_C1334.scale_x = 1.0
            col_C1334.scale_y = 1.0
            col_C1334.alignment = 'Expand'.upper()
            col_C1334.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            col_C1334.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], 'number', text='Number', icon_value=0, emboss=True)
            col_C1334.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], 'ring', text='Ring', icon_value=0, emboss=True, slider=True)
            col_C1334.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator, 'sna_kfire_angle', text='Angle', icon_value=0, emboss=True, slider=True)
            col_C1334.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], 'min', text='Min Size', icon_value=0, emboss=True, slider=True)
            attr_EA254 = '["' + str('Kfire_torch_width' + '"]') 
            col_C1334.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator, attr_EA254, text='Torch Width', icon_value=0, emboss=True, slider=True)
            col_C1334.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], 'noise_strength', text='Noise Strength', icon_value=0, emboss=True, slider=True)
            box_E010D = col_C329C.box()
            box_E010D.alert = False
            box_E010D.enabled = True
            box_E010D.active = True
            box_E010D.use_property_split = False
            box_E010D.use_property_decorate = False
            box_E010D.alignment = 'Expand'.upper()
            box_E010D.scale_x = 1.0
            box_E010D.scale_y = 1.0
            if not True: box_E010D.operator_context = "EXEC_DEFAULT"
            row_B2448 = box_E010D.row(heading='', align=True)
            row_B2448.alert = False
            row_B2448.enabled = True
            row_B2448.active = True
            row_B2448.use_property_split = False
            row_B2448.use_property_decorate = False
            row_B2448.scale_x = 1.0
            row_B2448.scale_y = 1.0
            row_B2448.alignment = 'Expand'.upper()
            row_B2448.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_B2448.label(text='Smoke Color', icon_value=0)
            row_B2448.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], 'fire_smoke_color', text='', icon_value=0, emboss=True)
            box_533F8 = col_C329C.box()
            box_533F8.alert = False
            box_533F8.enabled = True
            box_533F8.active = True
            box_533F8.use_property_split = False
            box_533F8.use_property_decorate = False
            box_533F8.alignment = 'Expand'.upper()
            box_533F8.scale_x = 1.0
            box_533F8.scale_y = 1.0
            if not True: box_533F8.operator_context = "EXEC_DEFAULT"
            row_69407 = box_533F8.row(heading='', align=True)
            row_69407.alert = False
            row_69407.enabled = True
            row_69407.active = True
            row_69407.use_property_split = False
            row_69407.use_property_decorate = False
            row_69407.scale_x = 1.0
            row_69407.scale_y = 1.0
            row_69407.alignment = 'Expand'.upper()
            row_69407.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_69407.label(text='', icon_value=_icons['deploy_kfire_sets_icon.png'].icon_id)
            op = row_69407.operator('sna.deploy_kfire_emitter_dcf39', text='to All', icon_value=0, emboss=True, depress=False)
            op.sna_all = True
            op = row_69407.operator('sna.deploy_kfire_emitter_dcf39', text='to Kfire Grp', icon_value=0, emboss=True, depress=False)
            op.sna_all = False
        if (len(bpy.context.scene.sna_fire_col) > 0):
            box_13195 = layout.box()
            box_13195.alert = False
            box_13195.enabled = True
            box_13195.active = True
            box_13195.use_property_split = False
            box_13195.use_property_decorate = False
            box_13195.alignment = 'Expand'.upper()
            box_13195.scale_x = 1.0
            box_13195.scale_y = 1.0
            if not True: box_13195.operator_context = "EXEC_DEFAULT"
            row_C356F = box_13195.row(heading='', align=False)
            row_C356F.alert = False
            row_C356F.enabled = True
            row_C356F.active = True
            row_C356F.use_property_split = False
            row_C356F.use_property_decorate = False
            row_C356F.scale_x = 1.0
            row_C356F.scale_y = 1.0
            row_C356F.alignment = 'Expand'.upper()
            row_C356F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_C356F.label(text='Fluid:', icon_value=0)
            row_C177C = row_C356F.row(heading='', align=False)
            row_C177C.alert = False
            row_C177C.enabled = True
            row_C177C.active = True
            row_C177C.use_property_split = False
            row_C177C.use_property_decorate = False
            row_C177C.scale_x = 1.0
            row_C177C.scale_y = 1.0
            row_C177C.alignment = 'Right'.upper()
            row_C177C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_C177C.template_icon(icon_value=_icons['KaFire_Fire_icon.png'].icon_id, scale=1.5)
            col_521F4 = box_13195.column(heading='', align=True)
            col_521F4.alert = False
            col_521F4.enabled = True
            col_521F4.active = True
            col_521F4.use_property_split = False
            col_521F4.use_property_decorate = False
            col_521F4.scale_x = 1.0
            col_521F4.scale_y = 1.0
            col_521F4.alignment = 'Expand'.upper()
            col_521F4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            split_D95B8 = col_521F4.split(factor=0.7242990732192993, align=True)
            split_D95B8.alert = False
            split_D95B8.enabled = True
            split_D95B8.active = True
            split_D95B8.use_property_split = False
            split_D95B8.use_property_decorate = False
            split_D95B8.scale_x = 1.0
            split_D95B8.scale_y = 1.0
            split_D95B8.alignment = 'Expand'.upper()
            if not True: split_D95B8.operator_context = "EXEC_DEFAULT"
            attr_F129D = '["' + str('Kfire_density' + '"]') 
            split_D95B8.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator, attr_F129D, text='Density', icon_value=0, emboss=True, slider=True)
            split_D95B8.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], 'fluid_absolute_density', text='Abs', icon_value=0, emboss=True, toggle=True)
            attr_63306 = '["' + str('Kfire_fuel' + '"]') 
            col_521F4.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator, attr_63306, text='Fuel', icon_value=0, emboss=True, slider=True)
            attr_F0298 = '["' + str('Kfire_source_velocity' + '"]') 
            col_521F4.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator, attr_F0298, text='Source Velocity', icon_value=0, emboss=True, slider=True)
            attr_21E12 = '["' + str('Kfire_normal_velocity' + '"]') 
            col_521F4.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator, attr_21E12, text='Normal Velocity', icon_value=0, emboss=True, slider=True)
            box_F065F = col_521F4.box()
            box_F065F.alert = False
            box_F065F.enabled = True
            box_F065F.active = True
            box_F065F.use_property_split = False
            box_F065F.use_property_decorate = False
            box_F065F.alignment = 'Expand'.upper()
            box_F065F.scale_x = 1.0
            box_F065F.scale_y = 1.0
            if not True: box_F065F.operator_context = "EXEC_DEFAULT"
            row_667A8 = box_F065F.row(heading='', align=True)
            row_667A8.alert = False
            row_667A8.enabled = True
            row_667A8.active = True
            row_667A8.use_property_split = False
            row_667A8.use_property_decorate = False
            row_667A8.scale_x = 1.0
            row_667A8.scale_y = 1.0
            row_667A8.alignment = 'Expand'.upper()
            row_667A8.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_667A8.label(text='', icon_value=_icons['deploy_kfire_fire_icon.png'].icon_id)
            op = row_667A8.operator('sna.deploy_kfire_fire_db5e5', text='to All', icon_value=0, emboss=True, depress=False)
            op.sna_all = True
            op = row_667A8.operator('sna.deploy_kfire_fire_db5e5', text='to Kfire Grp', icon_value=0, emboss=True, depress=False)
            op.sna_all = False
            row_A6B37 = box_13195.row(heading='', align=True)
            row_A6B37.alert = False
            row_A6B37.enabled = True
            row_A6B37.active = True
            row_A6B37.use_property_split = False
            row_A6B37.use_property_decorate = False
            row_A6B37.scale_x = 1.0
            row_A6B37.scale_y = 1.0
            row_A6B37.alignment = 'Expand'.upper()
            row_A6B37.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_A6B37.label(text='Smoke Domain', icon_value=_icons['Smoke_Domain_Icon.png'].icon_id)
            op = row_A6B37.operator('sna.create_kafire_domain_1ba2a', text='Create', icon_value=93, emboss=True, depress=False)
        if (len(bpy.context.scene.sna_fire_col) > 0):
            box_104AB = layout.box()
            box_104AB.alert = False
            box_104AB.enabled = True
            box_104AB.active = True
            box_104AB.use_property_split = False
            box_104AB.use_property_decorate = False
            box_104AB.alignment = 'Expand'.upper()
            box_104AB.scale_x = 1.0
            box_104AB.scale_y = 1.0
            if not True: box_104AB.operator_context = "EXEC_DEFAULT"
            col_841C4 = box_104AB.column(heading='', align=True)
            col_841C4.alert = False
            col_841C4.enabled = True
            col_841C4.active = True
            col_841C4.use_property_split = False
            col_841C4.use_property_decorate = False
            col_841C4.scale_x = 1.0
            col_841C4.scale_y = 1.0
            col_841C4.alignment = 'Expand'.upper()
            col_841C4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_AFEA5 = col_841C4.row(heading='', align=False)
            row_AFEA5.alert = False
            row_AFEA5.enabled = True
            row_AFEA5.active = True
            row_AFEA5.use_property_split = False
            row_AFEA5.use_property_decorate = False
            row_AFEA5.scale_x = 1.0
            row_AFEA5.scale_y = 1.0
            row_AFEA5.alignment = 'Expand'.upper()
            row_AFEA5.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_AFEA5.label(text='Particles:', icon_value=0)
            row_CB7A1 = row_AFEA5.row(heading='', align=False)
            row_CB7A1.alert = False
            row_CB7A1.enabled = True
            row_CB7A1.active = True
            row_CB7A1.use_property_split = False
            row_CB7A1.use_property_decorate = False
            row_CB7A1.scale_x = 1.0
            row_CB7A1.scale_y = 1.0
            row_CB7A1.alignment = 'Right'.upper()
            row_CB7A1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_CB7A1.template_icon(icon_value=169, scale=1.5)
            if bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].has_torch_part:
                op = col_841C4.operator('sna.remove_particles_0a771', text='Remove Particles', icon_value=33, emboss=True, depress=False)
            else:
                col_059E7 = col_841C4.column(heading='', align=False)
                col_059E7.alert = False
                col_059E7.enabled = True
                col_059E7.active = True
                col_059E7.use_property_split = False
                col_059E7.use_property_decorate = False
                col_059E7.scale_x = 1.0
                col_059E7.scale_y = 1.0
                col_059E7.alignment = 'Expand'.upper()
                col_059E7.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_059E7.label(text='Add Particles', icon_value=31)
                row_4AF4C = col_059E7.row(heading='', align=True)
                row_4AF4C.alert = False
                row_4AF4C.enabled = True
                row_4AF4C.active = True
                row_4AF4C.use_property_split = False
                row_4AF4C.use_property_decorate = False
                row_4AF4C.scale_x = 1.0
                row_4AF4C.scale_y = 1.0
                row_4AF4C.alignment = 'Expand'.upper()
                row_4AF4C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                op = row_4AF4C.operator('sna.add_fire_particles_1eb21', text='to Active', icon_value=0, emboss=True, depress=False)
                op.sna_col_index = bpy.context.scene.sna_fire_index
                op.sna_update = False
                op.sna_to_all_kafires = False
                op.sna_to_kafire_group = False
                op = row_4AF4C.operator('sna.add_fire_particles_1eb21', text='to All', icon_value=0, emboss=True, depress=False)
                op.sna_col_index = bpy.context.scene.sna_fire_index
                op.sna_update = False
                op.sna_to_all_kafires = True
                op.sna_to_kafire_group = False
                op = row_4AF4C.operator('sna.add_fire_particles_1eb21', text='to Grp', icon_value=0, emboss=True, depress=False)
                op.sna_col_index = bpy.context.scene.sna_fire_index
                op.sna_update = False
                op.sna_to_all_kafires = False
                op.sna_to_kafire_group = True
            row_F3120 = col_841C4.row(heading='', align=True)
            row_F3120.alert = False
            row_F3120.enabled = True
            row_F3120.active = True
            row_F3120.use_property_split = False
            row_F3120.use_property_decorate = False
            row_F3120.scale_x = 1.0
            row_F3120.scale_y = 1.0
            row_F3120.alignment = 'Expand'.upper()
            row_F3120.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_F3120.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], 'torch_part_thresold', text='Emission Threshold', icon_value=0, emboss=True)
            row_FC316 = row_F3120.row(heading='', align=True)
            row_FC316.alert = False
            row_FC316.enabled = bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].has_torch_part
            row_FC316.active = bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].has_torch_part
            row_FC316.use_property_split = False
            row_FC316.use_property_decorate = False
            row_FC316.scale_x = 1.0
            row_FC316.scale_y = 1.0
            row_FC316.alignment = 'Expand'.upper()
            row_FC316.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_FC316.operator('sna.add_fire_particles_1eb21', text='', icon_value=692, emboss=True, depress=False)
            op.sna_col_index = bpy.context.scene.sna_fire_index
            op.sna_update = True
            op.sna_to_all_kafires = False
            op.sna_to_kafire_group = False
            if bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].has_torch_part:
                box_88273 = col_841C4.box()
                box_88273.alert = False
                box_88273.enabled = True
                box_88273.active = True
                box_88273.use_property_split = True
                box_88273.use_property_decorate = False
                box_88273.alignment = 'Expand'.upper()
                box_88273.scale_x = 1.0
                box_88273.scale_y = 1.0
                if not True: box_88273.operator_context = "EXEC_DEFAULT"
                box_88273.label(text='Settings:', icon_value=233)
                box_88273.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].particles_emitter, 'sna_kfire_angle_offset', text='Angle Offset', icon_value=0, emboss=True)
                col_D6EB1 = box_88273.column(heading='', align=True)
                col_D6EB1.alert = False
                col_D6EB1.enabled = True
                col_D6EB1.active = True
                col_D6EB1.use_property_split = True
                col_D6EB1.use_property_decorate = False
                col_D6EB1.scale_x = 1.0
                col_D6EB1.scale_y = 1.0
                col_D6EB1.alignment = 'Expand'.upper()
                col_D6EB1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                col_D6EB1.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], 'torch_part_number', text='Count', icon_value=0, emboss=True)
                col_D6EB1.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index], 'torch_part_emission_duration', text='Duration', icon_value=0, emboss=True)
                op = col_D6EB1.operator('sna.kfop_set_particles_time_offset_0034c', text='Time Offset', icon_value=492, emboss=True, depress=False)
                op.sna_offset = 0
                attr_68211 = '["' + str('Kfire_particles_life' + '"]') 
                col_D6EB1.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].particles_emitter, attr_68211, text='Life', icon_value=0, emboss=True)
                attr_E11F4 = '["' + str('Kfire_particles_speed' + '"]') 
                col_D6EB1.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].particles_emitter, attr_E11F4, text='Speed', icon_value=0, emboss=True)
                attr_DED12 = '["' + str('Kfire_particles_random' + '"]') 
                col_D6EB1.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].particles_emitter, attr_DED12, text='Speed Rand', icon_value=0, emboss=True)
                attr_7EE66 = '["' + str('Kfire_particles_damping' + '"]') 
                col_D6EB1.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].particles_emitter, attr_7EE66, text='Damping', icon_value=0, emboss=True)
                attr_48EF8 = '["' + str('Kfire_smoke_particles_size' + '"]') 
                box_88273.prop(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].particles_emitter, attr_48EF8, text='Smoke Size', icon_value=657, emboss=True, expand=True)
                box_8AFA3 = box_88273.box()
                box_8AFA3.alert = False
                box_8AFA3.enabled = True
                box_8AFA3.active = True
                box_8AFA3.use_property_split = False
                box_8AFA3.use_property_decorate = False
                box_8AFA3.alignment = 'Expand'.upper()
                box_8AFA3.scale_x = 1.0
                box_8AFA3.scale_y = 1.0
                if not True: box_8AFA3.operator_context = "EXEC_DEFAULT"
                row_81C11 = box_8AFA3.row(heading='', align=True)
                row_81C11.alert = False
                row_81C11.enabled = True
                row_81C11.active = True
                row_81C11.use_property_split = False
                row_81C11.use_property_decorate = False
                row_81C11.scale_x = 1.0
                row_81C11.scale_y = 1.0
                row_81C11.alignment = 'Expand'.upper()
                row_81C11.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_81C11.label(text='', icon_value=_icons['deploy_settings_icon.png'].icon_id)
                op = row_81C11.operator('sna.deploy_kfire_particles_11a56', text='to All', icon_value=0, emboss=True, depress=False)
                op.sna_all = True
                op = row_81C11.operator('sna.deploy_kfire_particles_11a56', text='to Kfire Grp', icon_value=0, emboss=True, depress=False)
                op.sna_all = False


class SNA_OT_Mantaflow_Replay_C30D8(bpy.types.Operator):
    bl_idname = "sna.mantaflow_replay_c30d8"
    bl_label = "MantaFlow_Replay"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        domain = bpy.context.view_layer.objects.active
        domain_init_frame = domain.modifiers[0].domain_settings.cache_frame_start
        if bpy.context.scene.sna_fire_manta_replay:
            bpy.data.scenes["Scene"].frame_start = domain_init_frame
            bpy.context.scene.sna_fire_manta_replay = False
        else:       
            bpy.context.scene.frame_set(domain_init_frame)
            bpy.context.view_layer.update()
            bpy.context.scene.frame_set(domain_init_frame + 1)
            bpy.ops.screen.animation_play()
            bpy.data.scenes["Scene"].frame_start = domain_init_frame + 1
            bpy.context.scene.sna_fire_manta_replay = True
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


@persistent
def load_post_handler_E2B17(dummy):
    if (len(bpy.context.scene.sna_fire_col) > 0):
        for i_6446E in range(len(bpy.context.scene.sna_fire_col)):
            ob = bpy.context.scene.sna_fire_col[i_6446E].manipulator
            #import bpy 
            """
            bo : bpy_types.Object
            """

            def update_dependencies(ob):

                def updateExp(d):
                    # https://blender.stackexchange.com/questions/118350/how-to-update-the-dependencies-of-a-driver-via-python-script
                    d.driver.expression += " "
                    d.driver.expression = d.driver.expression[:-1]
                try:
                    drivers = ob.animation_data.drivers
                    for d in drivers:
                        updateExp(d)
                except AttributeError:
                    return
            update_dependencies(ob)
            recursiv = True
            ob = bpy.context.scene.sna_fire_col[i_6446E].manipulator
            children = None
            if recursiv:
                children = list(ob.children_recursive)
            else:
                children = list(ob.children)
            for i_3DCBC in range(len(children)):
                ob = children[i_3DCBC]
                #import bpy 
                """
                bo : bpy_types.Object
                """

                def update_dependencies(ob):

                    def updateExp(d):
                        # https://blender.stackexchange.com/questions/118350/how-to-update-the-dependencies-of-a-driver-via-python-script
                        d.driver.expression += " "
                        d.driver.expression = d.driver.expression[:-1]
                    try:
                        drivers = ob.animation_data.drivers
                        for d in drivers:
                            updateExp(d)
                    except AttributeError:
                        return
                update_dependencies(ob)
            if property_exists("bpy.context.scene.sna_fire_col[i_6446E].particles_emitter", globals(), locals()):
                ob = bpy.context.scene.sna_fire_col[i_6446E].particles_emitter
                #import bpy 
                """
                bo : bpy_types.Object
                """

                def update_dependencies(ob):

                    def updateExp(d):
                        # https://blender.stackexchange.com/questions/118350/how-to-update-the-dependencies-of-a-driver-via-python-script
                        d.driver.expression += " "
                        d.driver.expression = d.driver.expression[:-1]
                    try:
                        drivers = ob.animation_data.drivers
                        for d in drivers:
                            updateExp(d)
                    except AttributeError:
                        return
                update_dependencies(ob)


class SNA_OT_Create_Emission_Keyframes_5492A(bpy.types.Operator):
    bl_idname = "sna.create_emission_keyframes_5492a"
    bl_label = "create_emission_keyframes"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        kafire_manip = bpy.context.view_layer.objects.active
        scene_frame = bpy.context.scene.frame_current
        kafire_manip["Kfire_emission"] = 1.0
        kafire_manip.keyframe_insert('["Kfire_emission"]',frame=scene_frame)
        kafire_manip.keyframe_insert('["Kfire_emission"]',frame=scene_frame+1)
        kafire_manip["Kfire_emission"] = 0.0
        kafire_manip.keyframe_insert('["Kfire_emission"]',frame=scene_frame - 4)
        kafire_manip["Kfire_emission"] = 2.0
        kafire_manip.keyframe_insert('["Kfire_emission"]',frame=scene_frame + 3)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Clone_Kfire_38074(bpy.types.Operator):
    bl_idname = "sna.clone_kfire_38074"
    bl_label = "clone_kfire"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_col_index: bpy.props.IntProperty(name='col_index', description='', default=0, subtype='NONE')

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        manip = bpy.context.scene.sna_fire_col[self.sna_col_index].manipulator
        fire_item = bpy.context.scene.sna_fire_col[self.sna_col_index]
        index = self.sna_col_index
        #select kfire and its chldrens
        bpy.ops.object.select_all(action='DESELECT')
        manip.select_set(True)
        bpy.context.view_layer.objects.active = manip
        for child in manip.children_recursive:
            if 'KFire_Parts_Emitter' not in child.name:
                child.hide_select = False
                child.select_set(True)
        ###########################################
        #### duplique le tout:
        if bpy.app.version >= (4, 0, 0) and False:    
        # blender 4
            bpy.ops.object.duplicate_move(OBJECT_OT_duplicate={"linked":False, "mode":'TRANSLATION'}, TRANSFORM_OT_translate={"value":(0.0, 0.0, 0.0), "orient_type":'GLOBAL', "orient_matrix":((1, 0, 0), (0, 1, 0), (0, 0, 1)), "orient_matrix_type":'GLOBAL', "constraint_axis":(False, False, False), "mirror":False, "use_proportional_edit":False, "proportional_edit_falloff":'SMOOTH', "proportional_size":1, "use_proportional_connected":False, "use_proportional_projected":False, "snap":False, "snap_elements":{'INCREMENT'}, "use_snap_project":False, "snap_target":'CLOSEST', "use_snap_self":True, "use_snap_edit":True, "use_snap_nonedit":True, "use_snap_selectable":False, "snap_point":(0, 0, 0), "snap_align":False, "snap_normal":(0, 0, 0), "gpencil_strokes":False, "cursor_transform":False, "texture_space":False, "remove_on_cancel":False, "use_duplicated_keyframes":False, "view2d_edge_pan":False, "release_confirm":False, "use_accurate":False, "alt_navigation":True, "use_automerge_and_split":False})
        else:
            # blender 3.6
            bpy.ops.object.duplicate_move(OBJECT_OT_duplicate={"linked":False, "mode":'TRANSLATION'}, TRANSFORM_OT_translate={"value":(0.0, 0.0, 0.0), "orient_type":'GLOBAL', "orient_matrix":((1, 0, 0), (0, 1, 0), (0, 0, 1)), "orient_matrix_type":'GLOBAL', "constraint_axis":(False, False, False), "mirror":False, "use_proportional_edit":False, "proportional_edit_falloff":'SMOOTH', "proportional_size":1, "use_proportional_connected":False, "use_proportional_projected":False, "snap":False, "snap_elements":{'INCREMENT'}, "use_snap_project":False, "snap_target":'CLOSEST', "use_snap_self":True, "use_snap_edit":True, "use_snap_nonedit":True, "use_snap_selectable":False, "snap_point":(0, 0, 0), "snap_align":False, "snap_normal":(0, 0, 0), "gpencil_strokes":False, "cursor_transform":False, "texture_space":False, "remove_on_cancel":False, "view2d_edge_pan":False, "release_confirm":False, "use_accurate":False, "use_automerge_and_split":False})
        new_manip = bpy.context.selected_objects[0]
        ############################### 
        ###### add new kfire item to collection:
        bpy.context.scene.sna_fire_col.add()
        new_col_name = f'{random.randrange(16**8):x}'
        bpy.context.scene.sna_fire_col[len(bpy.context.scene.sna_fire_col)-1].name = new_col_name
        ###############################
        new_fire_item = bpy.context.scene.sna_fire_col[len(bpy.context.scene.sna_fire_col)-1]
        new_fire_item.manipulator = new_manip
        ######## pass data from parent(fire item) to new fire item:
        #new_fire_item.angle = fire_item.angle
        #new_fire_item.edit_lock = fire_item.edit_lock
        new_fire_item.fire_part_visibility = fire_item.fire_part_visibility
        new_fire_item.fire_type = fire_item.fire_type
        new_fire_item.fire_visibility = fire_item.fire_visibility
        new_fire_item.has_torch_part = False
        #new_fire_item.id   = fire_item.id  #####################################
        new_fire_item.ring = fire_item.ring
        new_fire_item.min = fire_item.min
        new_fire_item.noise_strength = fire_item.noise_strength
        new_fire_item.number = fire_item.number
        new_texture = fire_item.texture.copy()
        new_fire_item.texture = new_texture
        for child in new_manip.children_recursive:
            if 'torch_mesh' in child.name:
                for displace_mod in child.modifiers:
                    if 'noise_displace' in displace_mod.name:
                        displace_mod.texture = new_fire_item.texture
                child.animation_data.drivers[3].driver.variables[0].targets[0].data_path = 'sna_fire_col["' + new_col_name + '"].noise_strength'
                child.animation_data.drivers[4].driver.variables[0].targets[0].data_path = 'sna_fire_col["' + new_col_name + '"].noise_strength'
                child.animation_data.drivers[5].driver.variables[0].targets[0].data_path = 'sna_fire_col["' + new_col_name + '"].fire_smoke_color.r'
                child.animation_data.drivers[6].driver.variables[0].targets[0].data_path = 'sna_fire_col["' + new_col_name + '"].fire_smoke_color.g'
                child.animation_data.drivers[7].driver.variables[0].targets[0].data_path = 'sna_fire_col["' + new_col_name + '"].fire_smoke_color.b'
        new_fire_item.icon = fire_item.icon
        for child in manip.children_recursive:
            if 'KFire_Parts_Emitter' not in child.name:
                child.hide_select = True
        for child in new_manip.children_recursive:
            child.hide_select = True
        bpy.ops.object.select_all(action='DESELECT')
        ########## update col index:
        bpy.context.scene.sna_fire_index = len(bpy.context.scene.sna_fire_col)-1
        new_manip.select_set(True)
        bpy.context.view_layer.objects.active = new_manip
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Throw_Dice_D5632(bpy.types.Operator):
    bl_idname = "sna.throw_dice_d5632"
    bl_label = "throw_dice"
    bl_description = "随机属性"
    bl_options = {"REGISTER", "UNDO"}
    sna_col_index: bpy.props.IntProperty(name='col_index', description='', default=0, subtype='NONE')

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        manip = bpy.context.scene.sna_fire_col[self.sna_col_index].manipulator
        fire_item = bpy.context.scene.sna_fire_col[self.sna_col_index]
        from mathutils import Vector
        import random

        def set_torch_rotation(ring,angle,torch):
            angle_min = angle*ring
            if torch['Fire_kfi'] >= 0:
                fi = bl_math.lerp(angle_min, angle, torch['Fire_kfi'])
            else:
                fi = - bl_math.lerp(angle_min, angle, -torch['Fire_kfi']) 
            teta = torch['Fire_teta']
            #define direction
            DirectionVector = Vector((sin(fi)*cos(teta),sin(fi)*sin(teta),cos(fi)))
            torch['Fire_vector'] = DirectionVector
            #apply rotation
            torch.rotation_mode = 'QUATERNION'
            torch.rotation_quaternion = DirectionVector.to_track_quat('Z','X')
        angle = fire_item.angle
        ring = fire_item.ring
        torchs = [ (torch) for torch in manip.children if 'Torch' in torch.name ]
        for torch in torchs:
            torch['Fire_kfi'] = random.uniform(-1.0, 1.0)
            torch['Fire_teta'] = random.uniform(-pi, pi)         
            set_torch_rotation(ring,angle,torch)
        sna_update_fire_CF4A5(bpy.context.scene.sna_fire_col[self.sna_col_index].manipulator, bpy.context.scene.sna_fire_col[self.sna_col_index], self.sna_col_index)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Deploy_Kfire_Fire_Db5E5(bpy.types.Operator):
    bl_idname = "sna.deploy_kfire_fire_db5e5"
    bl_label = "Deploy_Kfire_Fire"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_all: bpy.props.BoolProperty(name='All', description='', default=False)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        deploy_to_all = self.sna_all
        kfire_col = bpy.context.scene.sna_fire_col
        kafire_current = kfire_col[bpy.context.scene.sna_fire_index]
        current_manip = kafire_current.manipulator
        current_id = current_manip["kfire_id"]
        density = current_manip["Kfire_density"]
        fuel = current_manip["Kfire_fuel"]
        source_volocity = current_manip["Kfire_source_velocity"]
        for kf in kfire_col:
            if kf.manipulator["kfire_id"] == current_id:
                kf.manipulator["Kfire_density"] = density
                kf.manipulator["Kfire_fuel"] = fuel
                kf.manipulator["Kfire_source_velocity"] = source_volocity
            else:
                if deploy_to_all:
                    kf.manipulator["Kfire_density"] = density
                    kf.manipulator["Kfire_fuel"] = fuel
                    kf.manipulator["Kfire_source_velocity"] = source_volocity
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Deploy_Kfire_Emitter_Dcf39(bpy.types.Operator):
    bl_idname = "sna.deploy_kfire_emitter_dcf39"
    bl_label = "Deploy_Kfire_Emitter"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_all: bpy.props.BoolProperty(name='All', description='', default=False)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        deploy_to_all = self.sna_all
        kfire_col = bpy.context.scene.sna_fire_col
        kafire_current = kfire_col[bpy.context.scene.sna_fire_index]
        current_manip = kafire_current.manipulator
        current_id = current_manip["kfire_id"]
        number = kafire_current.number
        ring = kafire_current.ring
        angle = current_manip.sna_kfire_angle
        min_size = kafire_current.min
        torch_width = current_manip["Kfire_torch_width"]
        strentgh = kafire_current.noise_strength
        smoke_color = kafire_current.fire_smoke_color
        for kf in kfire_col:
            if kf.manipulator["kfire_id"] == current_id:
                kf.number = number
                kf.ring = ring
                kf.manipulator.sna_kfire_angle = angle
                kf.min = min_size
                kf.manipulator["Kfire_torch_width"] = torch_width
                kf.noise_strength = strentgh
                kf.fire_smoke_color = smoke_color
            else:
                if deploy_to_all:
                    kf.number = number
                    kf.ring = ring
                    kf.manipulator.sna_kfire_angle = angle
                    kf.min = min_size
                    kf.manipulator["Kfire_torch_width"] = torch_width
                    kf.noise_strength = strentgh
                    kf.fire_smoke_color = smoke_color
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Deploy_Kfire_Particles_11A56(bpy.types.Operator):
    bl_idname = "sna.deploy_kfire_particles_11a56"
    bl_label = "Deploy_Kfire_Particles"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_all: bpy.props.BoolProperty(name='All', description='', default=False)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        deploy_to_all = self.sna_all

        def update_dependencies(ob):

            def updateExp(d):
                # https://blender.stackexchange.com/questions/118350/how-to-update-the-dependencies-of-a-driver-via-python-script
                d.driver.expression += " "
                d.driver.expression = d.driver.expression[:-1]
            try:
                drivers = ob.animation_data.drivers
                for d in drivers:
                    updateExp(d)
            except AttributeError:
                return
        kfire_col = bpy.context.scene.sna_fire_col
        kafire_current = kfire_col[bpy.context.scene.sna_fire_index]
        current_manip = kafire_current.manipulator
        current_part_emitter = kafire_current.particles_emitter
        current_id = current_manip["kfire_id"]
        angle_offset = current_part_emitter.sna_kfire_angle_offset
        number = kafire_current.torch_part_number
        duration = kafire_current.torch_part_emission_duration
        life = current_part_emitter["Kfire_particles_life"]
        Speed = current_part_emitter["Kfire_particles_speed"]
        Rand = current_part_emitter["Kfire_particles_random"]
        Damping = current_part_emitter["Kfire_particles_damping"]
        Size = current_part_emitter["Kfire_smoke_particles_size"]
        for kf in kfire_col:
            if kf.manipulator["kfire_id"] == current_id:
                if kf.has_torch_part:
                    kf.particles_emitter.sna_kfire_angle_offset = angle_offset
                    kf.torch_part_number = number
                    kf.particles_emitter.particle_systems[0].settings.count = number
                    kf.torch_part_emission_duration = duration
                    kf.particles_emitter["Kfire_particles_life"] = life
                    kf.particles_emitter["Kfire_particles_speed"] = Speed
                    kf.particles_emitter["Kfire_particles_random"] = Rand
                    kf.particles_emitter["Kfire_particles_damping"] = Damping
                    kf.particles_emitter["Kfire_smoke_particles_size"] = Size
                    update_dependencies(kf.particles_emitter)           
            else:
                if deploy_to_all:
                    if kf.has_torch_part:
                        kf.particles_emitter.sna_kfire_angle_offset = angle_offset
                        kf.torch_part_number = number
                        kf.particles_emitter.particle_systems[0].settings.count = number
                        kf.torch_part_emission_duration = duration
                        kf.particles_emitter["Kfire_particles_life"] = life
                        kf.particles_emitter["Kfire_particles_speed"] = Speed
                        kf.particles_emitter["Kfire_particles_random"] = Rand
                        kf.particles_emitter["Kfire_particles_damping"] = Damping
                        kf.particles_emitter["Kfire_smoke_particles_size"] = Size
                        update_dependencies(kf.particles_emitter)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Remove_Particles_0A771(bpy.types.Operator):
    bl_idname = "sna.remove_particles_0a771"
    bl_label = "Remove_Particles"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        emitter = bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].particles_emitter
        try:
            for d in emitter.animation_data.drivers:
                emitter.driver_remove(d.data_path)
            bpy.data.objects.remove(emitter)
        except:
            pass
        bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].has_torch_part = False
        sna_select_object_63C82(bpy.context.scene.sna_fire_col[bpy.context.scene.sna_fire_index].manipulator)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_update_fire_CF4A5(Fire_Manipulator, Item, Index):
    new_number = Item.number
    manipulator = Fire_Manipulator
    fire_item = Item
    col_index = Index
    min_size = Item.min
    col_name = bpy.context.scene.sna_fire_col[Index].name
    from mathutils import Vector
    import random

    def set_torch_rotation(ring,angle,torch):
        angle_min = angle*ring
        if torch['Fire_kfi'] >= 0:
            fi = bl_math.lerp(angle_min, angle, torch['Fire_kfi'])
        else:
            fi = - bl_math.lerp(angle_min, angle, -torch['Fire_kfi']) 
        teta = torch['Fire_teta']
        #define direction
        DirectionVector = Vector((sin(fi)*cos(teta),sin(fi)*sin(teta),cos(fi)))
        torch['Fire_vector'] = DirectionVector
        #apply rotation
        torch.rotation_mode = 'QUATERNION'
        torch.rotation_quaternion = DirectionVector.to_track_quat('Z','X')

    def is_addon_active(addon_name):
        addon_utils.modules(refresh=True)
        loaded_default, loaded_state = addon_utils.check(addon_name)
        return loaded_state
    ###### manage existing torchs
    torchs = [ (torch) for torch in manipulator.children if 'Torch' in torch.name ]
    kado_col = None
    sample_ob = None
    if is_addon_active('kadomain'):
        for child in manipulator.children_recursive:
            if 'torch_mesh' in child.name:
                sample_ob = child
                break
        for kado in bpy.context.scene.sna_kadomain_collection:
            if sample_ob in kado['flow_col'].objects[:]:
                kado_col = kado['flow_col']
    rest_number = new_number - len(torchs)
    angle = manipulator.sna_kfire_angle
    ring = fire_item.ring
    for torch in torchs:
        torch.empty_display_size = bl_math.lerp(min_size, 1.0, torch['size'])
        set_torch_rotation(ring,angle,torch)
    ###### manage new torchs
    if rest_number > 0:
        for n in range(len(torchs), new_number):
            bpy.ops.object.empty_add(type='SINGLE_ARROW', align='WORLD', location=(0, 0, 0), scale=(1, 1, 1))
            torch = bpy.context.object
            torch.hide_select = True
            # lock location:
            torch.lock_location[0] = True
            torch.lock_location[1] = True
            torch.lock_location[2] = True
            # put it in KaFires collection:
            sna_move_outliner_collection_object_A90B9_337FB(torch, 'KaFires')
            torch.name = 'Torch'
            ################################################### driver scaling torch
            new_driver = torch.driver_add('scale')
            for i in range(3):
                new_driver[i].driver.type = 'SCRIPTED'
                size_var = new_driver[i].driver.variables.new()
                size_var.name = 'size'
                size_var.targets[0].id_type = 'OBJECT'
                size_var.targets[0].id = torch
                size_var.targets[0].data_path = 'empty_display_size' 
                new_driver[i].driver.expression = 'size'
            ####################################################### create torch_mesh
            bpy.ops.mesh.primitive_cube_add(size=2, enter_editmode=False, align='WORLD', location=(0.0, 0.0, 0.0), scale=(1, 1, 1))
            torch_mesh = bpy.context.object
            torch_mesh.name = 'torch_mesh'
            sna_move_outliner_collection_object_A90B9_337FB(torch_mesh, 'KaFires')
            torch_mesh.hide_render = True
            torch_mesh.hide_select = True
            #torch_mesh.display_type = 'WIRE'
            torch_mesh.data = bpy.data.meshes['torch_mesh'].copy()
            torch_mesh.parent = torch
            if kado_col:
                kado_col.objects.link(torch_mesh)
            ################################################### driver scaling torch_mesh
            # SCALE
            scale_driver = torch_mesh.driver_add('scale')
            scale_driver[2].driver.type = 'SCRIPTED'
            size_var = scale_driver[2].driver.variables.new()
            size_var.name = 'size'
            size_var.targets[0].id_type = 'OBJECT'
            size_var.targets[0].id = torch
            size_var.targets[0].data_path = 'empty_display_size'                   
            scale_driver[2].driver.expression = 'size'
            # SHAPE KEYS
            start_emit_driver = torch_mesh.data.shape_keys.key_blocks['start_emit'].driver_add("value")        
            start_emit_driver.driver.type = 'SCRIPTED'
            factor_var = start_emit_driver.driver.variables.new()
            factor_var.name = 'emit'
            factor_var.targets[0].id_type = 'OBJECT'
            factor_var.targets[0].id = manipulator
            factor_var.targets[0].data_path = '["Kfire_emission"]'
            start_emit_driver.driver.expression = '1 - emit'
            end_emit_driver = torch_mesh.data.shape_keys.key_blocks['end_emit'].driver_add("value")        
            end_emit_driver.driver.type = 'SCRIPTED'
            factor_var = end_emit_driver.driver.variables.new()
            factor_var.name = 'emit'
            factor_var.targets[0].id_type = 'OBJECT'
            factor_var.targets[0].id = manipulator
            factor_var.targets[0].data_path = '["Kfire_emission"]'
            end_emit_driver.driver.expression = 'emit - 1'
            ################################################### modifier noise displace X
            displace_mod = torch_mesh.modifiers.new(('noise_displace_X'),'DISPLACE')
            displace_mod.texture = fire_item.texture
            displace_mod.texture_coords = 'OBJECT'
            displace_mod.texture_coords_object = manipulator
            displace_mod.direction = 'X'
            displace_mod.space = 'LOCAL'
            displace_mod.mid_level = .5
    #        disp_driver = displace_mod.driver_add('size')
    #        disp_driver.driver.type='SCRIPTED'
    #        disp_var = disp_driver.driver.variables.new()
    #        disp_var.name = 'size'
    #        disp_var.targets[0].id_type = 'OBJECT'
    #        disp_var.targets[0].id = manipulator
    #        disp_var.targets[0].data_path = 'fire_noise_size'
    #        disp_driver.driver.expression = 'size'
            disp_driver = displace_mod.driver_add('strength')
            disp_driver.driver.type='SCRIPTED'
            disp_var = disp_driver.driver.variables.new()
            disp_var.name = 'strength'
            disp_var.targets[0].id_type = 'SCENE'
            disp_var.targets[0].id = bpy.context.scene
            disp_var.targets[0].data_path = 'sna_fire_col["' + col_name + '"].noise_strength'
            disp_driver.driver.expression = 'strength'
            ################################################### modifier noise displace Y
            displace_mod = torch_mesh.modifiers.new(('noise_displace'),'DISPLACE')
            displace_mod.texture = fire_item.texture
            displace_mod.texture_coords = 'OBJECT'
            displace_mod.texture_coords_object = manipulator
            displace_mod.direction = 'Y'
            displace_mod.space = 'LOCAL'
            displace_mod.mid_level = .5
    #        disp_driver = displace_mod.driver_add('size')
    #        disp_driver.driver.type='SCRIPTED'
    #        disp_var = disp_driver.driver.variables.new()
    #        disp_var.name = 'size'
    #        disp_var.targets[0].id_type = 'OBJECT'
    #        disp_var.targets[0].id = manipulator
    #        disp_var.targets[0].data_path = 'fire_noise_size'
    #        disp_driver.driver.expression = 'size'
            disp_driver = displace_mod.driver_add('strength')
            disp_driver.driver.type='SCRIPTED'
            disp_var = disp_driver.driver.variables.new()
            disp_var.name = 'strength'
            disp_var.targets[0].id_type = 'SCENE'
            disp_var.targets[0].id = bpy.context.scene
            disp_var.targets[0].data_path = 'sna_fire_col["' + col_name + '"].noise_strength'
            disp_driver.driver.expression = 'strength'        
            for i in range(2):
                scale_driver[i].driver.type = 'SCRIPTED'
                width_var = scale_driver[i].driver.variables.new()
                width_var.name = 'width'
                width_var.targets[0].id_type = 'OBJECT'
                width_var.targets[0].id = manipulator
                width_var.targets[0].data_path = '["Kfire_torch_width"]' 
                width_var = scale_driver[i].driver.variables.new()
                width_var.name = 'emit'
                width_var.targets[0].id_type = 'OBJECT'
                width_var.targets[0].id = manipulator
                width_var.targets[0].data_path = '["Kfire_emission"]'           
                scale_driver[i].driver.expression = 'width if emit>0 else 0'
            #################################################### create fluid MODIFIER
            torch_mesh.modifiers.new('KFluid', 'FLUID')
            torch_mesh.modifiers['KFluid'].fluid_type = 'FLOW'
            torch_mesh.modifiers['KFluid'].flow_settings.flow_behavior = 'INFLOW'
            torch_mesh.modifiers['KFluid'].flow_settings.flow_source = 'MESH'
            torch_mesh.modifiers['KFluid'].flow_settings.flow_type = 'BOTH'
            torch_mesh.modifiers['KFluid'].flow_settings.volume_density = 0
            torch_mesh.modifiers["KFluid"].flow_settings.subframes = 5
            torch_mesh.modifiers["KFluid"].flow_settings.temperature = 1.0
            torch_mesh.modifiers['KFluid'].flow_settings.use_absolute = True
            torch_mesh.modifiers['KFluid'].flow_settings.particle_size = 1
            torch_mesh.modifiers['KFluid'].flow_settings.use_initial_velocity = True
            torch_mesh.modifiers['KFluid'].flow_settings.velocity_factor = 2
            torch_mesh.modifiers['KFluid'].flow_settings.velocity_normal = 1
            torch_mesh.modifiers['KFluid'].flow_settings.subframes = 0
            torch_mesh.modifiers["KFluid"].flow_settings.use_plane_init = True 
            ### MODIFIER ##################################################### drivers
            #color smoke
            color_driver = torch_mesh.driver_add('modifiers["KFluid"].flow_settings.smoke_color')
            color_driver[0].driver.type='SCRIPTED'
            color_var = color_driver[0].driver.variables.new()
            color_var.name = 'color'
            color_var.targets[0].id_type = 'SCENE'
            color_var.targets[0].id = bpy.context.scene
            color_var.targets[0].data_path = 'sna_fire_col["' + col_name + '"].fire_smoke_color.r'
            color_driver[0].driver.expression = 'pow(color,1/2.2)'
            color_driver[1].driver.type='SCRIPTED'
            color_var = color_driver[1].driver.variables.new()
            color_var.name = 'color'
            color_var.targets[0].id_type = 'SCENE'
            color_var.targets[0].id = bpy.context.scene
            color_var.targets[0].data_path = 'sna_fire_col["' + col_name + '"].fire_smoke_color.g'
            color_driver[1].driver.expression = 'pow(color,1/2.2)'
            color_driver[2].driver.type='SCRIPTED'
            color_var = color_driver[2].driver.variables.new()
            color_var.name = 'color'
            color_var.targets[0].id_type = 'SCENE'
            color_var.targets[0].id = bpy.context.scene
            color_var.targets[0].data_path = 'sna_fire_col["' + col_name + '"].fire_smoke_color.b'
            color_driver[2].driver.expression = 'pow(color,1/2.2)'
            # fuel
            fuel_driver = torch_mesh.driver_add('modifiers["KFluid"].flow_settings.fuel_amount')
            fuel_driver.driver.type='SCRIPTED'
            fuel_var = fuel_driver.driver.variables.new()
            fuel_var.name = 'fuel'        
            fuel_var.targets[0].id_type = 'OBJECT'
            fuel_var.targets[0].id = manipulator
            fuel_var.targets[0].data_path = '["Kfire_fuel"]'           
            fuel_driver.driver.expression = 'fuel'
            # density
            density_driver = torch_mesh.driver_add('modifiers["KFluid"].flow_settings.density')
            density_driver.driver.type='SCRIPTED'
            density_var = density_driver.driver.variables.new()
            density_var.name = 'density'
            density_var.targets[0].id_type = 'OBJECT'
            density_var.targets[0].id = manipulator
            density_var.targets[0].data_path = '["Kfire_density"]'       
            density_driver.driver.expression = 'density'
            # absolute density
    #        abs_density_driver = torch_mesh.driver_add('modifiers["KFluid"].flow_settings.use_absolute')
    #        abs_density_driver.driver.type='SCRIPTED'
    #        abs_density_var = abs_density_driver.driver.variables.new()
    #        abs_density_var.name = 'abs_density'
    #        abs_density_var.targets[0].id_type = 'OBJECT'
    #        abs_density_var.targets[0].id = manipulator
    #        abs_density_var.targets[0].data_path = '["Kfire_absolute_density"]'       
    #        abs_density_driver.driver.expression = 'abs_density'
            # source velocity
            source_velocity_driver = torch_mesh.driver_add('modifiers["KFluid"].flow_settings.velocity_factor')
            source_velocity_driver.driver.type='SCRIPTED'
            source_velocity_var = source_velocity_driver.driver.variables.new()
            source_velocity_var.name = 'source_velocity'
            source_velocity_var.targets[0].id_type = 'OBJECT'
            source_velocity_var.targets[0].id = manipulator
            source_velocity_var.targets[0].data_path = '["Kfire_source_velocity"]'         
            source_velocity_driver.driver.expression = 'source_velocity'
            # normal velocity
            normal_velocity_driver = torch_mesh.driver_add('modifiers["KFluid"].flow_settings.velocity_normal')
            normal_velocity_driver.driver.type='SCRIPTED'
            normal_velocity_var = normal_velocity_driver.driver.variables.new()
            normal_velocity_var.name = 'normal_velocity'
            normal_velocity_var.targets[0].id_type = 'OBJECT'
            normal_velocity_var.targets[0].id = manipulator
            normal_velocity_var.targets[0].data_path = '["Kfire_normal_velocity"]'         
            normal_velocity_driver.driver.expression = 'normal_velocity'
            # emission
            emit_driver = torch_mesh.driver_add('modifiers["KFluid"].flow_settings.surface_distance')
            emit_driver.driver.type='SCRIPTED'
            emit_var = emit_driver.driver.variables.new()
            emit_var.name = 'emit'
            emit_var.targets[0].id_type = 'OBJECT'
            emit_var.targets[0].id = manipulator
            emit_var.targets[0].data_path = '["Kfire_emission"]'        
            emit_driver.driver.expression = '1 - pow(emit-1,2)'
            ################################################################### object       
            torch.parent = manipulator
            torch['size'] = random.uniform(0.0,1.0)
            torch.empty_display_size = bl_math.lerp(min_size, 1.0, torch['size'])
            ################################################################### custom properties
            torch['order'] = n        
            torch['Fire_kfi'] = random.uniform(-1.0, 1.0)
            torch['Fire_teta'] = random.uniform(-pi, pi) #random.uniform(-pi, pi)
            set_torch_rotation(ring,angle,torch)
    else:
        ######## delete torchs
        for n in range(new_number, len(manipulator.children)):
            torchs = [ (torch) for torch in manipulator.children if 'Torch' in torch.name ]
            for torch in torchs:
                if torch['order'] == n:
                    bpy.data.objects.remove(torch.children[0])
                    bpy.data.objects.remove(torch)
    bpy.ops.object.select_all(action='DESELECT')
    manipulator.select_set(True)
    bpy.context.view_layer.objects.active = manipulator


def sna_add_fire_12BE5(icon_num):
    if property_exists("bpy.data.meshes['torch_mesh']", globals(), locals()):
        pass
    else:
        before_data = list(bpy.data.objects)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KaFire_Assets_0.1.04.blend') + r'\Object', filename='*_Fire_Emit_*', link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
        appended_754C9 = None if not new_data else new_data[0]
        sna_fn_remove_object_370A3(bpy.data.objects['*_Fire_Emit_*'])
    item_CAF65 = bpy.context.scene.sna_fire_col.add()
    id_0_6ec5b = sna_rand_hexa_number_string_BE9A1_6EC5B(8)
    bpy.context.scene.sna_fire_col[int(len(bpy.context.scene.sna_fire_col) - 1.0)].name = id_0_6ec5b
    before_data = list(bpy.data.objects)
    bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'KaFire_Assets_0.1.04.blend') + r'\Object', filename='kfire_manipulator', link=False)
    new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
    appended_5F5FF = None if not new_data else new_data[0]
    kafire['sna_tmp_fire'] = appended_5F5FF
    item_CAF65.icon = icon_num
    if str(icon_num) == "0":
        kafire['sna_tmp_fire'].color = ((1.0000001192092896, 0.8713672757148743, 0.23455063998699188)[0], (1.0000001192092896, 0.8713672757148743, 0.23455063998699188)[1], (1.0000001192092896, 0.8713672757148743, 0.23455063998699188)[2], 1.0)
    elif str(icon_num) == "1":
        kafire['sna_tmp_fire'].color = ((1.0000001192092896, 0.658375084400177, 0.0)[0], (1.0000001192092896, 0.658375084400177, 0.0)[1], (1.0000001192092896, 0.658375084400177, 0.0)[2], 1.0)
    elif str(icon_num) == "2":
        kafire['sna_tmp_fire'].color = ((1.0000001192092896, 0.4178851246833801, 0.0)[0], (1.0000001192092896, 0.4178851246833801, 0.0)[1], (1.0000001192092896, 0.4178851246833801, 0.0)[2], 1.0)
    elif str(icon_num) == "3":
        kafire['sna_tmp_fire'].color = ((1.0000001192092896, 0.21223078668117523, 0.0)[0], (1.0000001192092896, 0.21223078668117523, 0.0)[1], (1.0000001192092896, 0.21223078668117523, 0.0)[2], 1.0)
    elif str(icon_num) == "4":
        kafire['sna_tmp_fire'].color = ((1.0000001192092896, 0.07421357929706573, 0.0)[0], (1.0000001192092896, 0.07421357929706573, 0.0)[1], (1.0000001192092896, 0.07421357929706573, 0.0)[2], 1.0)
    elif str(icon_num) == "5":
        kafire['sna_tmp_fire'].color = ((0.45641112327575684, 0.0368894599378109, 0.0)[0], (0.45641112327575684, 0.0368894599378109, 0.0)[1], (0.45641112327575684, 0.0368894599378109, 0.0)[2], 1.0)
    elif str(icon_num) == "6":
        kafire['sna_tmp_fire'].color = ((0.35153263807296753, 0.009721221402287483, 0.0)[0], (0.35153263807296753, 0.009721221402287483, 0.0)[1], (0.35153263807296753, 0.009721221402287483, 0.0)[2], 1.0)
    else:
        pass
    item_CAF65.manipulator = kafire['sna_tmp_fire']
    kafire['sna_tmp_fire'].name = 'Kfire'
    kafire['sna_tmp_fire'].empty_display_size = 0.20000000298023224
    sna_move_outliner_collection_object_A90B9_337FB(kafire['sna_tmp_fire'], 'KaFires')
    id_0_f204e = sna_rand_hexa_number_string_BE9A1_F204E(5)
    item_CAF65.manipulator['kfire_id'] = id_0_f204e
    texture = None
    texture = bpy.data.textures.new('kfire_noise','CLOUDS')
    texture.noise_scale = .1
    item_CAF65.texture = texture
    bpy.context.scene.sna_fire_index = int(len(bpy.context.scene.sna_fire_col) - 1.0)
    sna_update_fire_CF4A5(kafire['sna_tmp_fire'], item_CAF65, int(len(bpy.context.scene.sna_fire_col) - 1.0))


def sna_select_object_63C82(object):
    ob = object
    bpy.ops.object.select_all(action='DESELECT')
    try:
        ob.select_set(True)
        bpy.context.view_layer.objects.active = ob
    except:
        pass


class SNA_GROUP_sna_fire_group(bpy.types.PropertyGroup):
    number: bpy.props.IntProperty(name='number', description='', default=5, subtype='NONE', min=1, max=1000, update=sna_update_number_D7CC9)
    ring: bpy.props.FloatProperty(name='ring', description='', default=0.0, subtype='NONE', unit='NONE', min=0.0, max=0.9990000128746033, step=3, precision=1, update=sna_update_ring_C3F9E)
    angle: bpy.props.FloatProperty(name='angle', description='', default=0.7850000262260437, subtype='ANGLE', unit='NONE', min=0.0010000000474974513, max=3.1415927410125732, step=5, precision=0)
    min: bpy.props.FloatProperty(name='min', description='', default=0.5, subtype='NONE', unit='NONE', min=0.0, max=1.0, step=3, precision=2, update=sna_update_min_F24B2)
    manipulator: bpy.props.PointerProperty(name='manipulator', description='', type=bpy.types.Object)
    edit_lock: bpy.props.BoolProperty(name='edit_lock', description='', default=True, update=sna_update_edit_lock_BBBEE)
    texture: bpy.props.PointerProperty(name='texture', description='', type=bpy.types.Texture)
    noise_strength: bpy.props.FloatProperty(name='noise_strength', description='', default=0.10000000149011612, subtype='NONE', unit='NONE', min=0.0, max=1.0, step=3, precision=2)
    fire_smoke_color: bpy.props.FloatVectorProperty(name='fire_smoke_color', description='', size=3, default=(0.49300000071525574, 0.5090000033378601, 0.6420000195503235), subtype='COLOR', unit='NONE', min=0.0, max=1.0, step=3, precision=6)
    has_torch_part: bpy.props.BoolProperty(name='has_torch_part', description='', default=False)
    torch_part_thresold: bpy.props.FloatProperty(name='torch_part_thresold', description='', default=0.8999999761581421, subtype='NONE', unit='NONE', min=0.0, step=3, precision=2)
    torch_part_number: bpy.props.IntProperty(name='torch_part_number', description='', default=5, subtype='NONE', min=1, update=sna_update_torch_part_number_1461B)
    torch_part_emission_duration: bpy.props.IntProperty(name='torch_part_emission_duration', description='', default=2, subtype='NONE', min=1, update=sna_update_torch_part_emission_duration_B03E1)
    torch_part_life: bpy.props.IntProperty(name='torch_part_life', description='', default=15, subtype='NONE', min=1)
    torch_part_speed: bpy.props.FloatProperty(name='torch_part_speed', description='', default=1.0, subtype='NONE', unit='NONE', min=0.0, step=3, precision=2)
    particles_emitter: bpy.props.PointerProperty(name='particles_emitter', description='', type=bpy.types.Object)
    particles_angle_offset: bpy.props.FloatProperty(name='particles_angle_offset', description='', default=0.0, subtype='ANGLE', unit='NONE', min=-1.5700000524520874, max=1.5700000524520874, step=3, precision=2)
    fire_type: bpy.props.EnumProperty(name='fire_type', description='', items=[('Smoke', 'Smoke', '', 0, 0), ('Fire + Smoke', 'Fire + Smoke', '', 0, 1), ('Fire', 'Fire', '', 0, 2)])
    fire_visibility: bpy.props.BoolProperty(name='fire_visibility', description='', default=True, update=sna_update_fire_visibility_405D5)
    fire_part_visibility: bpy.props.BoolProperty(name='fire_part_visibility', description='', default=True, update=sna_update_fire_part_visibility_911AB)
    icon: bpy.props.IntProperty(name='icon', description='', default=0, subtype='NONE', min=0, max=6)
    activ: bpy.props.BoolProperty(name='activ', description='Activation Toggle for Simulation', default=True, update=sna_update_activ_789A3)
    particle_time_offset: bpy.props.IntProperty(name='particle_time_offset', description='', default=0, subtype='NONE', min=-200, max=200)
    fluid_absolute_density: bpy.props.BoolProperty(name='fluid_absolute_density', description='', default=True, update=sna_update_fluid_absolute_density_E4ADC)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_GROUP_sna_fire_group)
    bpy.types.Scene.sna_fire_col = bpy.props.CollectionProperty(name='fire_col', description='', type=SNA_GROUP_sna_fire_group)
    bpy.types.Scene.sna_fire_index = bpy.props.IntProperty(name='fire_index', description='', default=0, subtype='NONE', update=sna_update_sna_fire_index_C5194)
    bpy.types.Scene.sna_previous_fire_index = bpy.props.IntProperty(name='previous_fire_index', description='', default=0, subtype='NONE')
    bpy.types.Scene.sna_fire_manta_replay = bpy.props.BoolProperty(name='fire_manta_replay', description='', default=False)
    bpy.types.Object.sna_kfire_angle = bpy.props.FloatProperty(name='kfire_angle', description='', default=0.7900000214576721, subtype='ANGLE', unit='NONE', min=0.0, max=3.141590118408203, step=5, precision=0, update=sna_update_sna_kfire_angle_4CFE2)
    bpy.types.Object.sna_kfire_angle_offset = bpy.props.FloatProperty(name='kfire_angle_offset', description='', default=0.0, subtype='ANGLE', unit='NONE', min=-1.5700000524520874, max=1.5700000524520874, step=3, precision=0)
    bpy.types.Scene.sna_hlep_emission_values = bpy.props.PointerProperty(name='hlep_emission_values', description='', type=bpy.types.Texture)
    bpy.utils.register_class(SNA_OT_Draw_Image_Ui_F6358)
    bpy.utils.register_class(SNA_OT_Kfop_Select_Active_Kafire_684Cf)
    bpy.utils.register_class(SNA_OT_Remove_Fire_Ba54A)
    bpy.utils.register_class(SNA_OT_Fire_Create_E4Cc2)
    bpy.utils.register_class(SNA_OT_Create_Kafire_Domain_1Ba2A)
    bpy.utils.register_class(SNA_OT_Add_Fire_Particles_1Eb21)
    bpy.utils.register_class(SNA_OT_Actualise_Index_From_Selection_7260C)
    bpy.utils.register_class(SNA_OT_Kfop_Set_Particles_Time_Offset_0034C)
    bpy.utils.register_class(SNA_PT_KAFIRE_5EF18)
    bpy.utils.register_class(SNA_UL_display_collection_list_AE408)
    if not 'KaFire_icon_inactiv.png' in _icons: _icons.load('KaFire_icon_inactiv.png', os.path.join(os.path.dirname(__file__), 'icons', 'KaFire_icon_inactiv.png'), "IMAGE")
    if not 'toch_off.png' in _icons: _icons.load('toch_off.png', os.path.join(os.path.dirname(__file__), 'icons', 'toch_off.png'), "IMAGE")
    if not 'toch_on.png' in _icons: _icons.load('toch_on.png', os.path.join(os.path.dirname(__file__), 'icons', 'toch_on.png'), "IMAGE")
    if not 'dices_icon.png' in _icons: _icons.load('dices_icon.png', os.path.join(os.path.dirname(__file__), 'icons', 'dices_icon.png'), "IMAGE")
    if not 'toch_on.png' in _icons: _icons.load('toch_on.png', os.path.join(os.path.dirname(__file__), 'icons', 'toch_on.png'), "IMAGE")
    if not 'deploy_kfire_sets_icon.png' in _icons: _icons.load('deploy_kfire_sets_icon.png', os.path.join(os.path.dirname(__file__), 'icons', 'deploy_kfire_sets_icon.png'), "IMAGE")
    if not 'KaFire_Fire_icon.png' in _icons: _icons.load('KaFire_Fire_icon.png', os.path.join(os.path.dirname(__file__), 'icons', 'KaFire_Fire_icon.png'), "IMAGE")
    if not 'deploy_kfire_fire_icon.png' in _icons: _icons.load('deploy_kfire_fire_icon.png', os.path.join(os.path.dirname(__file__), 'icons', 'deploy_kfire_fire_icon.png'), "IMAGE")
    if not 'Smoke_Domain_Icon.png' in _icons: _icons.load('Smoke_Domain_Icon.png', os.path.join(os.path.dirname(__file__), 'icons', 'Smoke_Domain_Icon.png'), "IMAGE")
    if not 'deploy_settings_icon.png' in _icons: _icons.load('deploy_settings_icon.png', os.path.join(os.path.dirname(__file__), 'icons', 'deploy_settings_icon.png'), "IMAGE")
    if not 'KaFire_icon.png' in _icons: _icons.load('KaFire_icon.png', os.path.join(os.path.dirname(__file__), 'icons', 'KaFire_icon.png'), "IMAGE")
    bpy.utils.register_class(SNA_OT_Mantaflow_Replay_C30D8)
    bpy.app.handlers.load_post.append(load_post_handler_E2B17)
    bpy.utils.register_class(SNA_OT_Create_Emission_Keyframes_5492A)
    bpy.utils.register_class(SNA_OT_Clone_Kfire_38074)
    bpy.utils.register_class(SNA_OT_Throw_Dice_D5632)
    bpy.utils.register_class(SNA_OT_Deploy_Kfire_Fire_Db5E5)
    bpy.utils.register_class(SNA_OT_Deploy_Kfire_Emitter_Dcf39)
    bpy.utils.register_class(SNA_OT_Deploy_Kfire_Particles_11A56)
    bpy.utils.register_class(SNA_OT_Remove_Particles_0A771)
    translate.register()


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_hlep_emission_values
    del bpy.types.Object.sna_kfire_angle_offset
    del bpy.types.Object.sna_kfire_angle
    del bpy.types.Scene.sna_fire_manta_replay
    del bpy.types.Scene.sna_previous_fire_index
    del bpy.types.Scene.sna_fire_index
    del bpy.types.Scene.sna_fire_col
    bpy.utils.unregister_class(SNA_GROUP_sna_fire_group)
    bpy.utils.unregister_class(SNA_OT_Draw_Image_Ui_F6358)
    if handler_961E1:
        bpy.types.SpaceView3D.draw_handler_remove(handler_961E1[0], 'WINDOW')
        handler_961E1.pop(0)
    bpy.utils.unregister_class(SNA_OT_Kfop_Select_Active_Kafire_684Cf)
    bpy.utils.unregister_class(SNA_OT_Remove_Fire_Ba54A)
    bpy.utils.unregister_class(SNA_OT_Fire_Create_E4Cc2)
    bpy.utils.unregister_class(SNA_OT_Create_Kafire_Domain_1Ba2A)
    bpy.utils.unregister_class(SNA_OT_Add_Fire_Particles_1Eb21)
    bpy.utils.unregister_class(SNA_OT_Actualise_Index_From_Selection_7260C)
    bpy.utils.unregister_class(SNA_OT_Kfop_Set_Particles_Time_Offset_0034C)
    bpy.utils.unregister_class(SNA_PT_KAFIRE_5EF18)
    bpy.utils.unregister_class(SNA_UL_display_collection_list_AE408)
    bpy.utils.unregister_class(SNA_OT_Mantaflow_Replay_C30D8)
    bpy.app.handlers.load_post.remove(load_post_handler_E2B17)
    bpy.utils.unregister_class(SNA_OT_Create_Emission_Keyframes_5492A)
    bpy.utils.unregister_class(SNA_OT_Clone_Kfire_38074)
    bpy.utils.unregister_class(SNA_OT_Throw_Dice_D5632)
    bpy.utils.unregister_class(SNA_OT_Deploy_Kfire_Fire_Db5E5)
    bpy.utils.unregister_class(SNA_OT_Deploy_Kfire_Emitter_Dcf39)
    bpy.utils.unregister_class(SNA_OT_Deploy_Kfire_Particles_11A56)
    bpy.utils.unregister_class(SNA_OT_Remove_Particles_0A771)
    translate.unregister()